// ADVENTURES
//

#include <ctype.h>
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#ifdef READ_DB
#include "cave.h"    // read the database cave.dat directly
#else
#include "db.h"      // use the prebuilt database
#endif

int LATNCY=10;   // How many minutes before resuming
int SETUP=0;
bool BLKLIN=true;
int SAVED;

int KEYS, LAMP, GRATE, CAGE, ROD, ROD2, STEPS, BIRD, DOOR, PILLOW, SNAKE;
int FISSUR, TABLET, CLAM, OYSTER, MAGZIN, DWARF, KNIFE, FOOD, BOTTLE;
int WATER, OIL, PLANT, PLANT2, AXE, MIRROR, DRAGON, CHASM, TROLL, TROLL2;
int BEAR, MESSAG, VEND, BATTER, NUGGET, COINS, CHEST, EGGS, TRIDNT, VASE;
int EMRALD, PYRAM, PEARL, RUG, CHAIN, SPICES, BACK, LOOK, CAVE, NUL, ENTRNC;
int DPRSSN, SAY, LOCK, THROW, FIND, INVENT;

//	COMMON /WIZCOM/ WKDAY,WKEND,HOLID,HBEGIN,HEND,HNAME,
//	1	SHORT,MAGIC,MAGNM,LATNCY,SAVET,SETUP
// //  ,HNAME(4)

//
// The following variables are all part of the state
//
time_t BEGSTATE;
//
// These variables must be global because functions use them.
//
int PLACE[OBJSIZ];
int FIXED[OBJSIZ];
int LINK[OBJSIZ*2];
int PROP[OBJSIZ];
int ATLOC[LOCSIZ];
int LOC;
int HOLDNG;
//
// These variables could be local to main() because they aren't used by any
// of the subroutines, but are here so they can be saved as part of the state.
//
int  ABB[LOCSIZ];
int  DLOC[7];
int  DSEEN[7];
int  HINTLC[HNTSIZ];
int  HINTED[HNTSIZ];
int  ODLOC[7];

int  ABBNUM;	// HOW OFTEN WE SHOULD PRINT NON-ABBREVIATED DESCRIPTIONS
int  CLOCK1;	// NUMBER OF TURNS FROM FINDING LAST TREASURE TILL CLOSING
int  CLOCK2;	// NUMBER OF TURNS FROM FIRST WARNING TILL BLINDING FLASH
bool CLOSED;    // SAYS WHETHER WE'RE ALL THE WAY CLOSED
bool CLOSNG;    // SAYS WHETHER ITS CLOSING TIME YET
int  DALTLC;
int  DETAIL;	// HOW OFTEN WE'VE SAID "NOT ALLOWED TO GIVE MORE DETAIL"
int  DFLAG;     // LEVEL OF DWARF ACTIVATION
int  DKILL;	// NUMBER OF DWARVES KILLED (UNUSED IN SCORING, NEEDED FOR MSG)
int  DTOTAL;
int  IWEST;	// HOW MANY TIMES HE'S SAID "WEST" INSTEAD OF "W"
int  KNFLOC;    // 0 IF NO KNIFE HERE, LOC IF KNIFE HERE, -1 AFTER CAVEAT
int  LIMIT;	// LIFETIME OF LAMP (NOT SET HERE)
bool LMWARN;    // SAYS WHETHER HE'S BEEN WARNED ABOUT LAMP GOING DIM
int  MAXDIE;	// NUMBER OF REINCARNATION MESSAGES AVAILABLE (UP TO 5)
int  NEWLOC;
int  NUMDIE;	// NUMBER OF TIMES KILLED SO FAR
int  OLDLOC;
int  OLDLC2;
bool PANIC;     // SAYS WHETHER HE'S FOUND OUT HE'S TRAPPED IN THE CAVE
int  TALLY;
int  TALLY2;
int  TURNS;	// TALLIES HOW MANY COMMANDS HE'S GIVEN (IGNORES YES/NO)
bool WZDARK;    // SAYS WHETHER THE LOC HE'S LEAVING WAS DARK

int ENDSTATE;


#define MAX0(A,B) ((A)>(B)?(A):(B))
#define MIN0(A,B) ((A)<(B)?(A):(B))
#define IABS(X)   abs(X)
#define MOD(A,B)  ((A)%(B))

// FORWARD REFERENCES

void BUG(int n);
void DROP(int object, int where);
int  VOCAB(char* word, int init);
bool START(int dummy);
int  RAN(int range);
void DATIME(int *, int *);
bool YES(int question, int yes_msg, int no_msg);
bool YESX(int question, int yes_msg, int no_msg, void (*spk)(int));
void RSPEAK(int msg);
void PSPEAK(int msg, int prop);
void SPEAK(int index);
void GETIN(char[5], char[5], char[5], char[5]);
void MOVE(int OBJ, int WHERE);
int  PUT(int OBJECT, int WHERE, int PVAL);
void CARRY(int OBJ, int WHERE);
void JUGGLE(int OBJ);
void DSTROY(int OBJ);



// STATEMENT FUNCTIONS
//
//
// TOTING(OBJ)	= TRUE IF THE OBJ IS BEING CARRIED
// HERE(OBJ)	= TRUE IF THE OBJ IS AT "LOC" (OR IS BEING CARRIED)
// AT(OBJ)	= TRUE IF ON EITHER SIDE OF TWO-PLACED OBJECT
// LIQ(DUMMY)	= OBJECT NUMBER OF LIQUID IN BOTTLE
// LIQLOC(LOC)	= OBJECT NUMBER OF LIQUID (IF ANY) AT LOC
// BITSET(L,N)	= TRUE IF COND(L) HAS BIT N SET (BIT 0 IS UNITS BIT)
// FORCED(LOC)	= TRUE IF LOC MOVES WITHOUT ASKING FOR INPUT (COND=2)
// DARK(DUMMY)	= TRUE IF LOCATION "LOC" IS DARK
// PCT(N)       = TRUE N% OF THE TIME (N INTEGER FROM 0 TO 100)
//
//	LOGICAL TOTING,HERE,AT,BITSET,DARK,WZDARK

// RETURN VAL LEFT-SHIFTED (LOGICALLY) DIST BITS (RIGHT-SHIFT IF DIST<0).

int SHIFT(int VAL, int DIST)
{
   if (DIST < 0) return VAL >> DIST;
   if (DIST > 0) return VAL << DIST;
   return VAL;
}
bool BITSET(int L, int N) { return (COND[L] & SHIFT(1,N))!=0; }

bool TOTING(int OBJ) { return PLACE[OBJ]==-1; }
bool HERE(int OBJ)   { return PLACE[OBJ]==LOC | TOTING(OBJ); }
bool DARK(int DUMMY) { return COND[LOC]%2==0 & (PROP[LAMP]==0 | !HERE(LAMP)); }
bool FORCED(int LOC) { return COND[LOC]==2; }
bool AT(int OBJ)     { return PLACE[OBJ]==LOC | FIXED[OBJ]==LOC; }
int LIQ2(int PBOTL) { return (1-PBOTL)*WATER+(PBOTL/2)*(WATER+OIL); }
int LIQ(int DUMMY)  { return LIQ2(MAX0(PROP[BOTTLE],-1-PROP[BOTTLE])); }
int LIQLOC(int LOC) { return LIQ2(((COND[LOC]/2*2)%8-5)*((COND[LOC]/4)%2)+1); }
bool PCT(int N)      { return RAN(100)<N; }
bool MATCH(char* str1, char* str2) { return strncasecmp(str1,str2,5)==0; }
bool EMPTY(char* str)              { return *str=='\0'; }
void CLEAR(char* str)              { for (int i=0; i<5; i++) *str++ = '\0'; }
void COPY(char* str1, char* str2)  { CLEAR(str1); strncpy(str1,str2,5); }

void CONCAT(char* dest, char* s1, char* s2) { 
  memset(dest,'\0',11); strncpy(dest,s1,5); strncat(dest,s2,10);
}

char *savename()
{
  static char name[256];
  char* home;

  home = getenv("HOME");
  if (home != NULL) {
    strcpy(name, home);
    strcat(name, "/.advstate");
  }
  else {
    strcpy(name, ".advstate");
  }
  return name;
}




int main()
{
  FILE *fp;
  char *beg, *end;

  const int CHLOC=114;
  const int CHLOC2=140;
  int MAXTRS;

  int  ATTACK;
  int  BONUS;	// USED TO DETERMINE AMOUNT OF BONUS IF HE REACHES CLOSING
  //bool DEMO;    // IS TRUE IF THIS IS A PRIME-TIME DEMONSTRATION GAME
  int  FOOBAR;	// CURRENT PROGRESS IN SAYING "FEE FIE FOE FOO".
  bool GAVEUP;  // SAYS WHETHER HE EXITED VIA "QUIT"
  int  HINT;
  int  I;
  int  J;
  int  K;
  int  K2;
  int  KK;
  int  KQ;
  int  LL;
  int  MXSCOR;
  int  OBJ;
  int  SCORE;
  bool SCORNG;  // INDICATES TO SCORE ROUTINE IF WE'RE DOING A "SCORE" COMMAND
  int  SPK;
  int  STICK;
  int  TK[21];
  int  VERB;
  char WD1[5], WD1X[5], WD2[5], WD2X[5];
  char WDSTR[12];
  bool YEA;     // IS RANDOM YES/NO REPLY

#ifdef READ_DB
  read_db();    // read the database file in from advent.dat
#endif

// FINISH CONSTRUCTING INTERNAL DATA FORMAT

// HAVING READ IN THE DATABASE, CERTAIN THINGS ARE NOW CONSTRUCTED.  PROPS ARE
// SET TO ZERO.  WE FINISH SETTING UP COND BY CHECKING FOR FORCED-MOTION TRAVEL
// ENTRIES.  THE PLAC AND FIXD ARRAYS ARE USED TO SET UP ATLOC(N) AS THE FIRST
// OBJECT AT LOCATION N, AND LINK[OBJ] AS THE NEXT OBJECT AT THE SAME LOCATION
// AS OBJ.  (OBJ>100 INDICATES THAT FIXED[OBJ-100]=LOC; LINK[OBJ] IS STILL THE
// CORRECT LINK TO USE.)  ABB IS ZEROED; IT CONTROLS WHETHER THE ABBREVIATED
// DESCRIPTION IS PRINTED.  COUNTS MOD 5 UNLESS "LOOK" IS USED.

        MAXTRS = OBJSIZ;

	for (I=1; I<OBJSIZ; I++) {
	  PLACE[I]=0;
	  PROP[I]=0;
	  LINK[I]=0;
	  LINK[I+OBJSIZ]=0;
	}

	for (I=1; I<LOCSIZ; I++) {
	  ABB[I]=0;
	  if (LTEXT[I]==0 | KEY[I]==0) goto L1102;
	  K=KEY[I];
	  if (MOD(IABS(TRAVEL[K]),1000)==1) COND[I]=2;  // forced motion
L1102:	  ATLOC[I]=0;
	}

// SET UP THE ATLOC AND LINK ARRAYS AS DESCRIBED ABOVE.  WE'LL USE THE DROP
// SUBROUTINE, WHICH PREFACES NEW OBJECTS ON THE LISTS.  SINCE WE WANT THINGS
// IN THE OTHER ORDER, WE'LL RUN THE LOOP BACKWARDS.  IF THE OBJECT IS IN TWO
// LOCS, WE DROP IT TWICE.  THIS ALSO SETS UP "PLACE" AND "FIXED" AS COPIES OF
// "PLAC" AND "FIXD".  ALSO, SINCE TWO-PLACED OBJECTS ARE TYPICALLY BEST
// DESCRIBED LAST, WE'LL DROP THEM FIRST.

	for (I=1; I<OBJSIZ; I++) {
	  K=OBJSIZ-I;
	  if (FIXD[K]>0) {
	    DROP(K+100,FIXD[K]);
	    DROP(K,PLAC[K]);
          }
	}

	for (I=1; I<OBJSIZ; I++) {
	  K=OBJSIZ-I;
	  FIXED[K]=FIXD[K];
	  if (PLAC[K]!=0 & FIXD[K]<=0) DROP(K,PLAC[K]);
	}

// TREASURES, AS NOTED EARLIER, ARE OBJECTS 50 THROUGH MAXTRS (CURRENTLY SET
// TO OBJSIZ). THEIR PROPS ARE INITIALLY -1, AND ARE SET TO 0 THE FIRST TIME 
// THEY ARE DESCRIBED.  TALLY KEEPS TRACK OF HOW MANY ARE NOT YET FOUND, SO 
// WE KNOW WHEN TO CLOSE THE CAVE.  TALLY2 COUNTS HOW MANY CAN NEVER BE FOUND 
// (E.G. IF LOST BIRD OR BRIDGE).

	TALLY=0;
	TALLY2=0;
	for (I=50; I<MAXTRS; I++) {
	  if (PTEXT[I]!=0) PROP[I]=-1;
	  TALLY=TALLY-PROP[I];
	}

// CLEAR THE HINT STUFF.  HINTLC(I) IS HOW LONG HE'S BEEN AT LOC WITH COND BIT
// I.  HINTED(I) IS TRUE IFF HINT I HAS BEEN USED.

	for (I=1; I<=HNTMAX; I++) {
	  HINTED[I]=false;
	  HINTLC[I]=0;
	}

// DEFINE SOME HANDY MNEMONICS.  THESE CORRESPOND TO OBJECT NUMBERS.

	KEYS=VOCAB("KEYS",1);
	LAMP=VOCAB("LAMP",1);
	GRATE=VOCAB("GRATE",1);
	CAGE=VOCAB("CAGE",1);
	ROD=VOCAB("ROD",1);
	ROD2=ROD+1;
	STEPS=VOCAB("STEPS",1);
	BIRD=VOCAB("BIRD",1);
	DOOR=VOCAB("DOOR",1);
	PILLOW=VOCAB("PILLO",1);
	SNAKE=VOCAB("SNAKE",1);
	FISSUR=VOCAB("FISSU",1);
	TABLET=VOCAB("TABLE",1);
	CLAM=VOCAB("CLAM",1);
	OYSTER=VOCAB("OYSTE",1);
	MAGZIN=VOCAB("MAGAZ",1);
	DWARF=VOCAB("DWARF",1);
	KNIFE=VOCAB("KNIFE",1);
	FOOD=VOCAB("FOOD",1);
	BOTTLE=VOCAB("BOTTL",1);
	WATER=VOCAB("WATER",1);
	OIL=VOCAB("OIL",1);
	PLANT=VOCAB("PLANT",1);
	PLANT2=PLANT+1;
	AXE=VOCAB("AXE",1);
	MIRROR=VOCAB("MIRRO",1);
	DRAGON=VOCAB("DRAGO",1);
	CHASM=VOCAB("CHASM",1);
	TROLL=VOCAB("TROLL",1);
	TROLL2=TROLL+1;
	BEAR=VOCAB("BEAR",1);
	MESSAG=VOCAB("MESSA",1);
	VEND=VOCAB("VENDI",1);
	BATTER=VOCAB("BATTE",1);

// OBJECTS FROM 50 THROUGH WHATEVER ARE TREASURES.  HERE ARE A FEW.

	NUGGET=VOCAB("GOLD",1);
	COINS=VOCAB("COINS",1);
	CHEST=VOCAB("CHEST",1);
	EGGS=VOCAB("EGGS",1);
	TRIDNT=VOCAB("TRIDE",1);
	VASE=VOCAB("VASE",1);
	EMRALD=VOCAB("EMERA",1);
	PYRAM=VOCAB("PYRAM",1);
	PEARL=VOCAB("PEARL",1);
	RUG=VOCAB("RUG",1);
	SPICES=VOCAB("SPICE",1);
	CHAIN=VOCAB("CHAIN",1);

// THESE ARE MOTION-VERB NUMBERS.

	BACK=VOCAB("BACK",0);
	LOOK=VOCAB("LOOK",0);
	CAVE=VOCAB("CAVE",0);
	NUL=VOCAB("NULL",0);
	ENTRNC=VOCAB("ENTRA",0);
	DPRSSN=VOCAB("DEPRE",0);

// AND SOME ACTION VERBS.

	SAY=VOCAB("SAY",2);
	LOCK=VOCAB("LOCK",2);
	THROW=VOCAB("THROW",2);
	FIND=VOCAB("FIND",2);
	INVENT=VOCAB("INVEN",2);

// INITIALISE THE DWARVES.  DLOC IS LOC OF DWARVES, HARD-WIRED IN.  ODLOC IS
// PRIOR LOC OF EACH DWARF, INITIALLY GARBAGE.  DALTLC IS ALTERNATE INITIAL LOC
// FOR DWARF, IN CASE ONE OF THEM STARTS OUT ON TOP OF THE ADVENTURER.  (NO 2
// OF THE 5 INITIAL LOCS ARE ADJACENT.)  DSEEN IS TRUE IF DWARF HAS SEEN HIM.
// DFLAG CONTROLS THE LEVEL OF ACTIVATION OF ALL THIS:
//	0	NO DWARF STUFF YET (WAIT UNTIL REACHES HALL OF MISTS)
//	1	REACHED HALL OF MISTS, BUT HASN'T MET FIRST DWARF
//	2	MET FIRST DWARF, OTHERS START MOVING, NO KNIVES THROWN YET
//	3	A KNIFE HAS BEEN THROWN (FIRST SET ALWAYS MISSES)
//	3+	DWARVES ARE MAD (INCREASES THEIR ACCURACY)
// SIXTH DWARF IS SPECIAL (THE PIRATE).  HE ALWAYS STARTS AT HIS CHEST'S
// EVENTUAL LOCATION INSIDE THE MAZE.  THIS LOC IS SAVED IN CHLOC FOR REF.
// THE DEAD END IN THE OTHER MAZE HAS ITS LOC STORED IN CHLOC2.

	for (I=1; I<7; I++) DSEEN[I]=false;
	DFLAG=0;
	DLOC[1]=19;
	DLOC[2]=27;
	DLOC[3]=33;
	DLOC[4]=44;
	DLOC[5]=64;
	DLOC[6]=CHLOC;
	DALTLC=18;

// OTHER RANDOM FLAGS AND COUNTERS, AS FOLLOWS:
// SEE DECLARATIONS FOR DESCRIPTION

	TURNS=0;
	WZDARK=false;
	LMWARN=false;
	IWEST=0;
	KNFLOC=0;
	DETAIL=0;
	ABBNUM=5;
	for (I=0; I<=4; I++) {
	  if (RTEXT[2*I+81]!=0) MAXDIE=I+1;
        }
	NUMDIE=0;
	HOLDNG=0;
	DKILL=0;
	FOOBAR=0;
	BONUS=0;
	CLOCK1=30;
	CLOCK2=50;
	//SAVED=0;
	SAVED=-1;    //so dwarves will take it easy
	CLOSNG=false;
	PANIC=false;
	CLOSED=false;
	GAVEUP=false;
	SCORNG=false;

// FINALLY, SINCE WE'RE CLEARLY SETTING THINGS UP FOR THE FIRST TIME...

#ifdef WIZARDRY
	CALL POOF;
#endif


// START-UP, DWARF STUFF;

	//DEMO=START(0);
	if (START(0)) goto L2000;
#ifdef WIZARDRY
	CALL MOTD(false);
#endif
	RAN(1);                   // start up the random number generator
	HINTED[3]=YES(65,1,0);
	NEWLOC=1;
	SETUP=3;
	LIMIT=330;
	if (HINTED[3]) LIMIT=1000;

// CAN'T LEAVE CAVE ONCE IT'S CLOSING (EXCEPT BY MAIN OFFICE).

L2:	if (NEWLOC>=9 | NEWLOC==0 | !CLOSNG) goto L71;
	RSPEAK(130);
	NEWLOC=LOC;
	if (!PANIC) CLOCK2=15;
	PANIC=true;

// SEE IF A DWARF HAS SEEN HIM AND HAS COME FROM WHERE HE WANTS TO GO.  IF SO,
// THE DWARF'S BLOCKING HIS WAY.  IF COMING FROM PLACE FORBIDDEN TO PIRATE
// (DWARVES ROOTED IN PLACE) LET HIM GET OUT (AND ATTACKED).

L71:	if (NEWLOC==LOC | FORCED(LOC) | BITSET(LOC,3)) goto L74;
	for (I=1; I<=5; I++) {
	  if (ODLOC[I]==NEWLOC & DSEEN[I]) {
	    NEWLOC=LOC;
	    RSPEAK(2);
	    goto L74;
	  }
	}
L74:	LOC=NEWLOC;

// DWARF STUFF.  SEE EARLIER COMMENTS FOR DESCRIPTION OF VARIABLES.  REMEMBER
// SIXTH DWARF IS PIRATE AND IS THUS VERY DIFFERENT EXCEPT FOR MOTION RULES.

// FIRST OFF, DON'T LET THE DWARVES FOLLOW HIM INTO A PIT OR A WALL.  ACTIVATE
// THE WHOLE MESS THE FIRST TIME HE GETS AS FAR AS THE HALL OF MISTS (LOC 15).
// IF NEWLOC IS FORBIDDEN TO PIRATE (IN PARTICULAR, IF IT'S BEYOND THE TROLL
// BRIDGE), BYPASS DWARF STUFF.  THAT WAY PIRATE CAN'T STEAL RETURN TOLL, AND
//  DWARVES CAN'T MEET THE BEAR.  ALSO MEANS DWARVES WON'T FOLLOW HIM INTO DEAD
// END IN MAZE, BUT C'EST LA VIE.  THEY'LL WAIT FOR HIM OUTSIDE THE DEAD END.

	if (LOC==0 | FORCED(LOC) | BITSET(NEWLOC,3)) goto L2000;
	if (DFLAG!=0) goto L6000;
	if (LOC>=15) DFLAG=1;
	goto L2000;

// WHEN WE ENCOUNTER THE FIRST DWARF, WE KILL 0, 1, OR 2 OF THE 5 DWARVES.  IF
// ANY OF THE SURVIVORS IS AT LOC, REPLACE HIM WITH THE ALTERNATE.

L6000:	if (DFLAG!=1) goto L6010;
	if (LOC<15 | PCT(95)) goto L2000;
	DFLAG=2;
	for (I=1; I<=2; I++) {
	  J=1+RAN(5);
// IF SAVED NOT = -1, HE BYPASSED THE "START" CALL.
	  if (PCT(50) & SAVED==-1) DLOC[J]=0;
	}
	for (I=1; I<=5; I++) {
	  if (DLOC[I]==LOC) DLOC[I]=DALTLC;
	  ODLOC[I]=DLOC[I];
	}
	RSPEAK(3);
	DROP(AXE,LOC);
	goto L2000;

// THINGS ARE IN FULL SWING.  MOVE EACH DWARF AT RANDOM, EXCEPT IF HE'S SEEN US
// HE STICKS WITH US.  DWARVES NEVER GO TO LOCS <15.  IF WANDERING AT RANDOM,
// THEY DON'T BACK UP UNLESS THERE'S NO ALTERNATIVE.  IF THEY DON'T HAVE TO
// MOVE, THEY ATTACK.  AND, OF COURSE, DEAD DWARVES DON'T DO MUCH OF ANYTHING.

L6010:	DTOTAL=0;
	ATTACK=0;
	STICK=0;
	for (I=1; I<=6; I++) {
	  if (DLOC[I]==0) continue;
	  J=1;
	  KK=DLOC[I];
	  KK=KEY[KK];
	  if (KK==0) goto L6016;
L6012:	  NEWLOC=MOD(IABS(TRAVEL[KK])/1000,1000);
	  if (NEWLOC>300 | NEWLOC<15 | NEWLOC==ODLOC[I] |
	         (J>1 & NEWLOC==TK[J-1]) | J>=20 | NEWLOC==DLOC[I] | 
	                    FORCED(NEWLOC) | (I==6 & BITSET(NEWLOC,3)) | 
	                            IABS(TRAVEL[KK])/1000000==100) goto L6014;
	  TK[J]=NEWLOC;
	  J=J+1;
L6014:	  KK=KK+1;
	  if (TRAVEL[KK-1]>=0) goto L6012;
L6016:	  TK[J]=ODLOC[I];
	  if (J>=2) J=J-1;
	  J=1+RAN(J);
	  ODLOC[I]=DLOC[I];
	  DLOC[I]=TK[J];
	  DSEEN[I]=(DSEEN[I] & LOC>=15) | (DLOC[I]==LOC | ODLOC[I]==LOC);
	  if (!DSEEN[I]) continue;
	  DLOC[I]=LOC;
	  if (I!=6) goto L6027;

// THE PIRATE'S SPOTTED HIM.  HE LEAVES HIM ALONE ONCE WE'VE FOUND CHEST.
// K COUNTS IF A TREASURE IS HERE.  IF NOT, AND TALLY=TALLY2 PLUS ONE FOR
// AN UNSEEN CHEST, LET THE PIRATE BE SPOTTED.

	  if (LOC==CHLOC | PROP[CHEST]>=0) continue;
	  K=0;
	  for (J=50; J<MAXTRS; J++) {
// PIRATE WON'T TAKE PYRAMID FROM PLOVER ROOM OR DARK ROOM (TOO EASY!).
	    if (J==PYRAM & (LOC==PLAC[PYRAM] | LOC==PLAC[EMRALD])) goto L6020;
	    if (TOTING(J)) goto L6022;
L6020:	    if (HERE(J)) K=1;
	  }
	  if (TALLY==TALLY2+1 & K==0 & PLACE[CHEST]==0 &
		                 HERE(LAMP) & PROP[LAMP]==1) goto L6025;
	  if (ODLOC[6]!=DLOC[6] & PCT(20)) RSPEAK(127);  // Faint rustling
	  continue;

L6022:	  RSPEAK(128);    // The pirate is ripping him off
// DON'T STEAL CHEST BACK FROM TROLL!
	  if (PLACE[MESSAG]==0) MOVE(CHEST,CHLOC);
	  MOVE(MESSAG,CHLOC2);
	  for (J=50; J<MAXTRS; J++) {
	    if (J==PYRAM & (LOC==PLAC[PYRAM] | LOC==PLAC[EMRALD])) continue;
	    if (AT(J) & FIXED[J]==0) CARRY(J,LOC);
	    if (TOTING(J)) DROP(J,CHLOC);
	  }
L6024:	  DLOC[6]=CHLOC;
	  ODLOC[6]=CHLOC;
	  DSEEN[6]=false;
	  continue;

L6025:	  RSPEAK(186);    // The pirate's been spotted
	  MOVE(CHEST,CHLOC);
	  MOVE(MESSAG,CHLOC2);
	  goto L6024;

// THIS THREATENING LITTLE DWARF IS IN THE ROOM WITH HIM!

L6027:	  DTOTAL=DTOTAL+1;
	  if (ODLOC[I]!=DLOC[I]) continue;
	  ATTACK=ATTACK+1;
	  if (KNFLOC>=0) KNFLOC=LOC;
	  if (RAN(1000)<95*(DFLAG-2)) STICK=STICK+1;
	}

// NOW WE KNOW WHAT'S HAPPENING.  LET'S TELL THE POOR SUCKER ABOUT IT.

	if (DTOTAL==0) goto L2000;
	if (DTOTAL==1) goto L75;
	printf("\nThere are %d threatening little dwarves "
                                            "in the room with you.\n", DTOTAL);
	goto L77;
L75:	RSPEAK(4);
L77: 
#ifdef DEBUG
printf("DTOTAL: %d  ATTACK: %d  DFLAG: %d  STICK: %d  SAVED: %d\n", 
							DTOTAL, ATTACK, DFLAG, STICK, SAVED);
#endif
	if (ATTACK==0) goto L2000;
	if (DFLAG==2) DFLAG=3;
// IF SAVED NOT = -1, HE BYPASSED THE "START" CALL.  DWARVES GET *VERY* MAD!
	if (SAVED!=-1) DFLAG=20;
	if (ATTACK==1) goto L79;
	printf("%d of them throw knives at you!\n", ATTACK);
	K=6;
L82:	if (STICK>1) goto L83;
	RSPEAK(K+STICK);
	if (STICK==0) goto L2000;
	goto L84;
L83:	printf("%d of them get you!\n", STICK);
L84:	OLDLC2=LOC;
	goto L99;

L79:	RSPEAK(5);
	K=52;
	goto L82;


// DESCRIBE THE CURRENT LOCATION AND (MAYBE) GET NEXT COMMAND.

// PRINT TEXT FOR CURRENT LOC.

L2000:	if (LOC==0) goto L99;
	KK=STEXT[LOC];
	if (MOD(ABB[LOC],ABBNUM)==0 | KK==0) KK=LTEXT[LOC];
	if (FORCED(LOC) | !DARK(0)) goto L2001;
	if (WZDARK & PCT(35)) goto L90;
	KK=RTEXT[16];
L2001:	if (TOTING(BEAR)) RSPEAK(141);
	SPEAK(KK);
	K=1;
	if (FORCED(LOC)) goto L8;
	if (LOC==33 & PCT(25) & !CLOSNG) RSPEAK(8);

// PRINT OUT DESCRIPTIONS OF OBJECTS AT THIS LOCATION.  IF NOT CLOSING AND
// PROPERTY VALUE IS NEGATIVE, TALLY OFF ANOTHER TREASURE.  RUG IS SPECIAL
// CASE; ONCE SEEN, ITS PROP IS 1 (DRAGON ON IT) TILL DRAGON IS KILLED.
// SIMILARLY FOR CHAIN; PROP IS INITIALLY 1 (LOCKED TO BEAR).  THESE HACKS
// ARE BECAUSE PROP=0 IS NEEDED TO GET FULL SCORE.

	if (DARK(0)) goto L2012;
	ABB[LOC]=ABB[LOC]+1;
	I=ATLOC[LOC];
L2004:	if (I==0) {
	  BLKLIN=true;   // just in case it was turned off
	  goto L2012;
	}
	OBJ=I;
	if (OBJ>100) OBJ=OBJ-100;
	if (OBJ==STEPS && TOTING(NUGGET)) goto L2008;
	if (PROP[OBJ]>=0) goto L2006;
	if (CLOSED) goto L2008;
	PROP[OBJ]=0;
	if (OBJ==RUG | OBJ==CHAIN) PROP[OBJ]=1;
	TALLY=TALLY-1;

// IF REMAINING TREASURES TOO ELUSIVE, ZAP HIS LAMP.
	if (TALLY==TALLY2 & TALLY!=0) LIMIT=MIN0(35,LIMIT);
L2006:	KK=PROP[OBJ];
	if (OBJ==STEPS & LOC==FIXED[STEPS]) KK=1;
	PSPEAK(OBJ,KK);
	BLKLIN=false;
L2008:	I=LINK[I];
	goto L2004;

L2009:	K=54;
L2010:	SPK=K;
L2011:	RSPEAK(SPK);

L2012:	VERB=0;
	OBJ=0;

// CHECK IF THIS LOC IS ELIGIBLE FOR ANY HINTS.  IF BEEN HERE LONG ENOUGH,
// BRANCH TO HELP SECTION (ON LATER PAGE).  HINTS ALL COME BACK HERE EVENTUALLY
// TO FINISH THE LOOP.  IGNORE "HINTS" < 4 (SPECIAL STUFF, SEE DATABASE NOTES).

L2600:	for (HINT=4; HINT<=HNTMAX; HINT++) {
          if (!HINTED[HINT]) {
	    if (!BITSET(LOC,HINT)) HINTLC[HINT]=-1;
	    HINTLC[HINT]=HINTLC[HINT]+1;
	    if (HINTLC[HINT]>=HINTS[HINT].TRNS) goto L40000;
	  }
        }

// KICK THE RANDOM NUMBER GENERATOR JUST TO ADD VARIETY TO THE CHASE.  ALSO,
// IF CLOSING TIME, CHECK FOR ANY OBJECTS BEING TOTED WITH PROP < 0 AND SET
// THE PROP TO -1-PROP.  THIS WAY OBJECTS WON'T BE DESCRIBED UNTIL THEY'VE
// BEEN PICKED UP AND PUT DOWN SEPARATE FROM THEIR RESPECTIVE PILES.  DON'T
// TICK CLOCK1 UNLESS WELL INTO CAVE (AND NOT AT Y2).

L2602:	if (!CLOSED) goto L2605;
	if (PROP[OYSTER]<0 & TOTING(OYSTER)) PSPEAK(OYSTER,1);
	for (I=1; I<OBJSIZ; I++) {
	  if (TOTING(I) & PROP[I]<0) PROP[I]=-1-PROP[I];
	}
L2605:	WZDARK=DARK(0);
	if (KNFLOC>0 & KNFLOC!=LOC)KNFLOC=0;
	I=RAN(1);

#ifdef DEBUG
printf("LOC:%d  PIRATE:%d  TURNS:%d  CLOCK1:%d  CLOCK2:%d\n", 
        LOC,    DLOC[6],   TURNS,    CLOCK1,    CLOCK2);
#endif

	GETIN(WD1,WD1X,WD2,WD2X);

// EVERY INPUT, CHECK "FOOBAR" FLAG.  IF ZERO, NOTHING'S GOING ON.  IF POS,
// MAKE NEG.  IF NEG, HE SKIPPED A WORD, SO MAKE IT ZERO.

L2608:	FOOBAR=MIN0(0,-FOOBAR);
#ifdef WIZARDRY
	if (TURNS==0 & WD1=='MAGIC' & WD2=='MODE') MAINT;
#endif
	TURNS=TURNS+1;
#ifdef WIZARDRY
	if (DEMO & TURNS>=SHORT) goto L13000;
#endif
	if (VERB==SAY & !EMPTY(WD2)) VERB=0;
	if (VERB==SAY) goto L4090;
	if (TALLY==0 & LOC>=15 & LOC!=33) CLOCK1=CLOCK1-1;
	if (CLOCK1==0) goto L10000;
	if (CLOCK1<0) CLOCK2=CLOCK2-1;
	if (CLOCK2==0) goto L11000;
	if (PROP[LAMP]==1) LIMIT=LIMIT-1;
	if (LIMIT<=30 & HERE(BATTER) & PROP[BATTER]==0 & HERE(LAMP)) {
	  goto L12000;
	}
	if (LIMIT==0) goto L12400;
	if (LIMIT<0 & LOC<=8) goto L12600;
	if (LIMIT<=30) goto L12200;
L19999:	K=43;
	if (LIQLOC(LOC)==WATER) K=70;
	if (MATCH(WD1,"ENTER") & (MATCH(WD2,"STREA") | MATCH(WD2,"WATER"))) {
	  goto L2010;
	}
	if (MATCH(WD1,"ENTER") & !EMPTY(WD2)) goto L2800;
	if ((!MATCH(WD1,"WATER") & !MATCH(WD1,"OIL"))
		 | (!MATCH(WD2,"PLANT") & !MATCH(WD2,"DOOR"))) goto L2610;
	if (AT(VOCAB(WD2,1))) COPY(WD2,"POUR");
L2610:	if (MATCH(WD1,"WEST")) {
          IWEST=IWEST+1;
	  if (IWEST==10) RSPEAK(17);
        }
L2630:	I=VOCAB(WD1,-1);
	if (I==-1) goto L3000;
	K=MOD(I,1000);
	KQ=I/1000+1;
        switch (KQ) {
         case 1: goto L8;
	 case 2: goto L5000;
	 case 3: goto L4000;
         case 4: goto L2010;
        }
	BUG(22);

// GET SECOND WORD FOR ANALYSIS.

L2800:	COPY(WD1,WD2);
	COPY(WD1X,WD2X);
	CLEAR(WD2);
	goto L2610;

// GEE, I DON'T UNDERSTAND.

L3000:	SPK=60;
	if (PCT(20))SPK=61;
	if (PCT(20)) SPK=13;
	RSPEAK(SPK);
	goto L2600;

// ANALYSE A VERB.  REMEMBER WHAT IT WAS, GO BACK FOR OBJECT IF SECOND WORD
// UNLESS VERB IS "SAY", WHICH SNARFS ARBITRARY SECOND WORD.

L4000:	VERB=K;
	SPK=ACTSPK[VERB];
	if (!EMPTY(WD2) & VERB!=SAY) goto L2800;
	if (VERB==SAY | OBJ!=0) goto L4090;

// ANALYSE AN INTRANSITIVE VERB (IE, NO OBJECT GIVEN YET).

	switch (VERB) {
          case 1:  goto L8010;  // TAKE
          case 2:  goto L8000;  // DROP
          case 3:  goto L8000;  // SAY
          case 4:  goto L8040;  // OPEN
          case 5:  goto L2009;  // NOTHING
          case 6:  goto L8040;  // LOCK
          case 7:  goto L9070;  // ON
          case 8:  goto L9080;  // OFF
          case 9:  goto L8000;  // WAVE
          case 10: goto L8000;  // CALM
          case 11: goto L2011;  // WALK
          case 12: goto L9120;  // KILL
          case 13: goto L9130;  // POUR
          case 14: goto L8140;  // EAT
          case 15: goto L9150;  // DRINK
          case 16: goto L8000;  // RUB
          case 17: goto L8000;  // TOSS
          case 18: goto L8180;  // QUIT
          case 19: goto L8000;  // FIND
          case 20: goto L8200;  // INVENTORY
          case 21: goto L8000;  // FEED
          case 22: goto L9220;  // FILL
          case 23: goto L9230;  // BLAST
          case 24: goto L8240;  // SCORE
          case 25: goto L8250;  // FOO
          case 26: goto L8260;  // BRIEF
          case 27: goto L8270;  // READ
          case 28: goto L8000;  // BREAK
          case 29: goto L8000;  // WAKE
          case 30: goto L8300;  // SUSP
          case 31: goto L8310;  // HOUR
	}
	BUG(23);

// ANALYSE A TRANSITIVE VERB.

L4090:	switch (VERB) {
          case 1:  goto L9010;  // TAKE
          case 2:  goto L9020;  // DROP
          case 3:  goto L9030;  // SAY
          case 4:  goto L9040;  // OPEN
          case 5:  goto L2009;  // NOTHING
          case 6:  goto L9040;  // LOCK
          case 7:  goto L9070;  // ON
          case 8:  goto L9080;  // OFF
          case 9:  goto L9090;  // WAVE
          case 10: goto L2011;  // CALM
          case 11: goto L2011;  // WALK
          case 12: goto L9120;  // KILL
          case 13: goto L9130;  // POUR
          case 14: goto L9140;  // EAT
          case 15: goto L9150;  // DRINK
          case 16: goto L9160;  // RUB
          case 17: goto L9170;  // TOSS
          case 18: goto L2011;  // QUIT
          case 19: goto L9190;  // FIND
          case 20: goto L9190;  // INVENTORY
          case 21: goto L9210;  // FEED
          case 22: goto L9220;  // FILL
          case 23: goto L9230;  // BLAST
          case 24: goto L2011;  // SCORE
          case 25: goto L2011;  // FOO
          case 26: goto L2011;  // BREIF
          case 27: goto L9270;  // READ
          case 28: goto L9280;  // BREAK
          case 29: goto L9290;  // WAKE
          case 30: goto L2011;  // SUSP
          case 31: goto L2011;  // HOUR
	}
	BUG(24);

// ANALYSE AN OBJECT WORD.  SEE IF THE THING IS HERE, WHETHER WE'VE GOT A VERB
// YET, AND SO ON.  OBJECT MUST BE HERE UNLESS VERB IS "FIND" OR "INVENT(ORY)"
// (AND NO NEW VERB YET TO BE ANALYSED).  WATER AND OIL ARE ALSO FUNNY, SINCE
// THEY ARE NEVER ACTUALLY DROPPED AT ANY LOCATION, BUT MIGHT BE HERE INSIDE
// THE BOTTLE OR AS A FEATURE OF THE LOCATION.

L5000:	OBJ=K;
	if (FIXED[K]!=LOC & !HERE(K)) goto L5100;
L5010:	if (!EMPTY(WD2)) goto L2800;
	if (VERB!=0) goto L4090;
	printf("\nWhat do you want to do with the %s%s?\n",WD1,WD1X);
	goto L2600;

L5100:	if (K!=GRATE) goto L5110;
	if (LOC==1 | LOC==4 | LOC==7) K=DPRSSN;
	if (LOC>9 & LOC<15) K=ENTRNC;
	if (K!=GRATE) goto L8;
L5110:	if (K!=DWARF) goto L5120;
	for (I=1; I<=5; I++) {
	  if (DLOC[I]==LOC & DFLAG>=2) goto L5010;
	}
L5120:	if ((LIQ(0)==K & HERE(BOTTLE)) | K==LIQLOC(LOC)) goto L5010;
	if (OBJ!=PLANT | !AT(PLANT2) | PROP[PLANT2]==0) goto L5130;
	OBJ=PLANT2;
	goto L5010;

L5130:	if (OBJ!=KNIFE | KNFLOC!=LOC) goto L5140;
	KNFLOC=-1;
	SPK=116;
	goto L2011;

L5140:	if (OBJ!=ROD | !HERE(ROD2)) goto L5190;
	OBJ=ROD2;
	goto L5010;

L5190:	if ((VERB==FIND | VERB==INVENT) & WD2==0) goto L5010;
	CONCAT(WDSTR,WD1,WD1X);
	printf("\nI see no %s here.\n", WDSTR);
	goto L2012;


// FIGURE OUT THE NEW LOCATION;
//
// GIVEN THE CURRENT LOCATION IN "LOC", AND A MOTION VERB NUMBER IN "K", PUT
// THE NEW LOCATION IN "NEWLOC".  THE CURRENT LOC IS SAVED IN "OLDLOC" IN CASE
// HE WANTS TO RETREAT.  THE CURRENT OLDLOC IS SAVED IN OLDLC2, IN CASE HE
// DIES.  (IF HE DOES, NEWLOC WILL BE LIMBO, AND OLDLOC WILL BE WHAT KILLED
// HIM, SO WE NEED OLDLC2, WHICH IS THE LAST PLACE HE WAS SAFE.)

L8:	KK=KEY[LOC];
	NEWLOC=LOC;
	if (KK==0) BUG(26);
	if (K==NUL) goto L2;
	if (K==BACK) goto L20;
	if (K==LOOK) goto L30;
	if (K==CAVE) goto L40;
	OLDLC2=OLDLOC;
	OLDLOC=LOC;

L9:	LL=IABS(TRAVEL[KK]);
	if (MOD(LL,1000)==1 | MOD(LL,1000)==K) goto L10;
	if (TRAVEL[KK]<0) goto L50;
	KK=KK+1;
	goto L9;

L10:	LL=LL/1000;
L11:	NEWLOC=LL/1000;
	K=MOD(NEWLOC,100);
	if (NEWLOC<=300) goto L13;
	if (PROP[K]!=NEWLOC/100-3) goto L16;
L12:	if (TRAVEL[KK]<0) BUG(25);
	KK=KK+1;
	NEWLOC=IABS(TRAVEL[KK])/1000;
	if (NEWLOC==LL) goto L12;
	LL=NEWLOC;
	goto L11;

L13:	if (NEWLOC<=100) goto L14;
	if (TOTING(K) | (NEWLOC>200 & AT(K))) goto L16;
	goto L12;

L14:	if (NEWLOC!=0 & !PCT(NEWLOC)) goto L12;
L16:	NEWLOC=MOD(LL,1000);
	if (NEWLOC<=300) goto L2;
	if (NEWLOC<=500) goto L30000;
	RSPEAK(NEWLOC-500);
	NEWLOC=LOC;
	goto L2;

// SPECIAL MOTIONS COME HERE.  LABELLING CONVENTION: STATEMENT NUMBERS NNNXX
// (XX=00-99) ARE USED FOR SPECIAL CASE NUMBER NNN (NNN=301-500).

L30000:	NEWLOC=NEWLOC-300;
	switch (NEWLOC) {
	  case 1: goto L30100;
	  case 2: goto L30200;
	  case 3: goto L30300;
	}
	BUG(20);

// TRAVEL 301.  PLOVER-ALCOVE PASSAGE.  CAN CARRY ONLY EMERALD.  NOTE: TRAVEL
// TABLE MUST INCLUDE "USELESS" ENTRIES GOING THROUGH PASSAGE, WHICH CAN NEVER
// BE USED FOR ACTUAL MOTION, BUT CAN BE SPOTTED BY "GO BACK".

L30100:	NEWLOC=99+100-LOC;
	if (HOLDNG==0 | (HOLDNG==1 & TOTING(EMRALD))) goto L2;
	NEWLOC=LOC;
	RSPEAK(117);
	goto L2;

// TRAVEL 302.  PLOVER TRANSPORT.  DROP THE EMERALD (ONLY USE SPECIAL TRAVEL IF
// TOTING IT), SO HE'S FORCED TO USE THE PLOVER-PASSAGE TO GET IT OUT.  HAVING
// DROPPED IT, GO BACK AND PRETEND HE WASN'T CARRYING IT AFTER ALL.

L30200:	DROP(EMRALD,LOC);
	goto L12;

// TRAVEL 303.  TROLL BRIDGE.  MUST BE DONE ONLY AS SPECIAL MOTION SO THAT
// DWARVES WON'T WANDER ACROSS AND ENCOUNTER THE BEAR.  (THEY WON'T FOLLOW THE
// PLAYER THERE BECAUSE THAT REGION IS FORBIDDEN TO THE PIRATE.)  IF
// PROP(TROLL)=1, HE'S CROSSED SINCE PAYING, SO STEP OUT AND BLOCK HIM.
// (STANDARD TRAVEL ENTRIES CHECK FOR PROP(TROLL)=0.)  SPECIAL STUFF FOR BEAR.

L30300:	if (PROP[TROLL]!=1) goto L30310;
	PSPEAK(TROLL,1);
	PROP[TROLL]=0;
	MOVE(TROLL2,0);
	MOVE(TROLL2+100,0);
	MOVE(TROLL,PLAC[TROLL]);
	MOVE(TROLL+100,FIXD[TROLL]);
	JUGGLE(CHASM);
	NEWLOC=LOC;
	goto L2;

L30310:	NEWLOC=PLAC[TROLL]+FIXD[TROLL]-LOC;
	if (PROP[TROLL]==0) PROP[TROLL]=1;
	if (!TOTING(BEAR)) goto L2;
	RSPEAK(162);
	PROP[CHASM]=1;
	PROP[TROLL]=2;
	DROP(BEAR,NEWLOC);
	FIXED[BEAR]=-1;
	PROP[BEAR]=3;
	if (PROP[SPICES]<0) TALLY2=TALLY2+1;
	OLDLC2=NEWLOC;
	goto L99;

// END OF SPECIALS.

// HANDLE "GO BACK".  LOOK FOR VERB WHICH GOES FROM LOC TO OLDLOC, OR TO OLDLC2
// IF OLDLOC HAS FORCED-MOTION.  K2 SAVES ENTRY -> FORCED LOC -> PREVIOUS LOC.

L20:	K=OLDLOC;
	if (FORCED(K)) K=OLDLC2;
	OLDLC2=OLDLOC;
	OLDLOC=LOC;
	K2=0;
	if (K!=LOC) goto L21;
	RSPEAK(91);
	goto L2;

L21:	LL=MOD((IABS(TRAVEL[KK])/1000),1000);
	if (LL==K) goto L25;
	if (LL>300) goto L22;
	J=KEY[LL];
	if (FORCED(LL) & MOD((IABS(TRAVEL[J])/1000),1000)==K) K2=KK;
L22:	if (TRAVEL[KK]<0) goto L23;
	KK=KK+1;
	goto L21;

L23:	KK=K2;
	if (KK!=0) goto L25;
	RSPEAK(140);
	goto L2;

L25:	K=MOD(IABS(TRAVEL[KK]),1000);
	KK=KEY[LOC];
	goto L9;

// LOOK.  CAN'T GIVE MORE DETAIL.  PRETEND IT WASN'T DARK (THOUGH IT MAY "NOW"
// BE DARK) SO HE WON'T FALL INTO A PIT WHILE STARING INTO THE GLOOM.

L30:	if (DETAIL<3) RSPEAK(15);
	DETAIL=DETAIL+1;
	WZDARK=false;
	ABB[LOC]=0;
	goto L2;

// CAVE.  DIFFERENT MESSAGES DEPENDING ON WHETHER ABOVE GROUND.

L40:	if (LOC<8) RSPEAK(57);
	if (LOC>=8) RSPEAK(58);
	goto L2;

// NON-APPLICABLE MOTION.  VARIOUS MESSAGES DEPENDING ON WORD GIVEN.

L50:	SPK=12;
	if (K>=43 & K<=50) SPK=9;
	if (K==29 | K==30) SPK=9;
	if (K==7 | K==36 | K==37) SPK=10;
	if (K==11 | K==19) SPK=11;
	if (VERB==FIND | VERB==INVENT) SPK=59;
	if (K==62 | K==65) SPK=42;
	if (K==17) SPK=80;
	RSPEAK(SPK);
	goto L2;


// "YOU'RE DEAD, JIM.";
//
// IF THE CURRENT LOC IS ZERO, IT MEANS THE CLOWN GOT HIMSELF KILLED.  WE'LL
// ALLOW THIS MAXDIE TIMES.  MAXDIE IS AUTOMATICALLY SET BASED ON THE NUMBER OF
// SNIDE MESSAGES AVAILABLE.  EACH DEATH RESULTS IN A MESSAGE (81, 83, ETC.)
// WHICH OFFERS REINCARNATION; IF ACCEPTED, THIS RESULTS IN MESSAGE 82, 84,
// ETC.  THE LAST TIME, IF HE WANTS ANOTHER CHANCE, HE GETS A SNIDE REMARK AS
// WE EXIT.  WHEN REINCARNATED, ALL OBJECTS BEING CARRIED GET DROPPED AT OLDLC2
// (PRESUMABLY THE LAST PLACE PRIOR TO BEING KILLED) WITHOUT CHANGE OF PROPS.
// THE LOOP RUNS BACKWARDS TO ASSURE THAT THE BIRD IS DROPPED BEFORE THE CAGE.
// (THIS KLUGE COULD BE CHANGED ONCE WE'RE SURE ALL REFERENCES TO BIRD AND CAGE
// ARE DONE BY KEYWORDS.)  THE LAMP IS A SPECIAL CASE (IT WOULDN'T DO TO LEAVE
// IT IN THE CAVE).  IT IS TURNED OFF AND LEFT OUTSIDE THE BUILDING (ONLY IF HE
// WAS CARRYING IT, OF COURSE).  HE HIMSELF IS LEFT INSIDE THE BUILDING (AND
// HEAVEN HELP HIM IF HE TRIES TO XYZZY BACK INTO THE CAVE WITHOUT THE LAMP!).
// OLDLOC IS ZAPPED SO HE CAN'T JUST "RETREAT".

// THE EASIEST WAY TO GET KILLED IS TO FALL INTO A PIT IN PITCH DARKNESS.

L90:	RSPEAK(23);
	OLDLC2=LOC;

// OKAY, HE'S DEAD.  LET'S GET ON WITH IT.

L99:	if (CLOSNG) goto L95;
	YEA=YES(81+NUMDIE*2,82+NUMDIE*2,54);
	NUMDIE=NUMDIE+1;
	if (NUMDIE==MAXDIE | !YEA) goto L20000;
	PLACE[WATER]=0;
	PLACE[OIL]=0;
	if (TOTING(LAMP)) PROP[LAMP]=0;
	for (J=1; J<OBJSIZ; J++) {
	  I=OBJSIZ-J;
	  if (!TOTING(I)) continue;
	  K=OLDLC2;
	  if (I==LAMP) K=1;
	  DROP(I,K);
	}
	LOC=3;
	OLDLOC=LOC;
	goto L2000;

// HE DIED DURING CLOSING TIME.  NO RESURRECTION.  TALLY UP A DEATH AND EXIT.

L95:	RSPEAK(131);
	NUMDIE=NUMDIE+1;
	goto L20000;


// ROUTINES FOR PERFORMING THE VARIOUS ACTION VERBS;

// STATEMENT NUMBERS IN THIS SECTION ARE 8000 FOR INTRANSITIVE VERBS, 9000 FOR
// TRANSITIVE, PLUS TEN TIMES THE VERB NUMBER.  MANY INTRANSITIVE VERBS USE THE
// TRANSITIVE CODE, AND SOME VERBS USE CODE FOR OTHER VERBS, AS NOTED BELOW.

// RANDOM INTRANSITIVE VERBS COME HERE.  CLEAR OBJ JUST IN CASE (SEE "ATTACK").

L8000:	CONCAT(WDSTR,WD1,WD1X);
	WDSTR[0] = toupper(WDSTR[0]);
	for (I=1; I<10; I++) WDSTR[I] = tolower(WDSTR[I]);
	printf("\n%s what?\n",WDSTR);
	OBJ=0;
	goto L2600;

// CARRY, NO OBJECT GIVEN YET.  OK IF ONLY ONE OBJECT PRESENT.

L8010:	if (ATLOC[LOC]==0 | LINK[ATLOC[LOC]]!=0) goto L8000;
	for (I=1; I<=5; I++) {
	  if (DLOC[I]==LOC & DFLAG>=2) goto L8000;
	}
	OBJ=ATLOC[LOC];

// CARRY AN OBJECT.  SPECIAL CASES FOR BIRD AND CAGE (IF BIRD IN CAGE, CAN'T
// TAKE ONE WITHOUT THE OTHER.  LIQUIDS ALSO SPECIAL, SINCE THEY DEPEND ON
// STATUS OF BOTTLE.  ALSO VARIOUS SIDE EFFECTS, ETC.

L9010:	if (TOTING(OBJ)) goto L2011;
	SPK=25;
	if (OBJ==PLANT & PROP[PLANT]<=0) SPK=115;
	if (OBJ==BEAR & PROP[BEAR]==1) SPK=169;
	if (OBJ==CHAIN & PROP[BEAR]!=0) SPK=170;
	if (FIXED[OBJ]!=0) goto L2011;
	if (OBJ!=WATER & OBJ!=OIL) goto L9017;
	if (HERE(BOTTLE) & LIQ(0)==OBJ) goto L9018;
	OBJ=BOTTLE;
	if (TOTING(BOTTLE) & PROP[BOTTLE]==1) goto L9220;
	if (PROP[BOTTLE]!=1) SPK=105;
	if (!TOTING(BOTTLE)) SPK=104;
	goto L2011;
L9018:	OBJ=BOTTLE;
L9017:	if (HOLDNG<7) goto L9016;
	RSPEAK(92);
	goto L2012;
L9016:	if (OBJ!=BIRD) goto L9014;
	if (PROP[BIRD]!=0) goto L9014;
	if (!TOTING(ROD)) goto L9013;
	RSPEAK(26);
	goto L2012;
L9013:	if (TOTING(CAGE)) goto L9015;
	RSPEAK(27);
	goto L2012;
L9015:	PROP[BIRD]=1;
L9014:	if ((OBJ==BIRD | OBJ==CAGE) & PROP[BIRD]!=0) CARRY(BIRD+CAGE-OBJ,LOC);
	CARRY(OBJ,LOC);
	K=LIQ(0);
	if (OBJ==BOTTLE & K!=0) PLACE[K]=-1;
	goto L2009;

// DISCARD OBJECT. "THROW" ALSO COMES HERE FOR MOST OBJECTS.  SPECIAL CASES FOR
// BIRD (MIGHT ATTACK SNAKE OR DRAGON) AND CAGE (MIGHT CONTAIN BIRD) AND VASE.
// DROP COINS AT VENDING MACHINE FOR EXTRA BATTERIES.

L9020:	if (TOTING(ROD2) & OBJ==ROD & !TOTING(ROD)) OBJ=ROD2;
	if (!TOTING(OBJ)) goto L2011;
	if (OBJ!=BIRD | !HERE(SNAKE)) goto L9024;
	RSPEAK(30);
	if (CLOSED) goto L19000;
	DSTROY(SNAKE);
// SET PROP FOR USE BY TRAVEL OPTIONS
	PROP[SNAKE]=1;
L9021:	K=LIQ(0);
	if (K==OBJ) OBJ=BOTTLE;
	if (OBJ==BOTTLE & K!=0) PLACE[K]=0;
	if (OBJ==CAGE & PROP[BIRD]!=0) DROP(BIRD,LOC);
	if (OBJ==BIRD) PROP[BIRD]=0;
	DROP(OBJ,LOC);
	goto L2012;

L9024:	if (OBJ!=COINS | !HERE(VEND)) goto L9025;
	DSTROY(COINS);
	DROP(BATTER,LOC);
	PSPEAK(BATTER,0);
	goto L2012;

L9025:	if (OBJ!=BIRD | !AT(DRAGON) | PROP[DRAGON]!=0) goto L9026;
	RSPEAK(154);
	DSTROY(BIRD);
	PROP[BIRD]=0;
	if (PLACE[SNAKE]==PLAC[SNAKE])TALLY2=TALLY2+1;
	goto L2012;

L9026:	if (OBJ!=BEAR | !AT(TROLL)) goto L9027;
	RSPEAK(163);
	MOVE(TROLL,0);
	MOVE(TROLL+100,0);
	MOVE(TROLL2,PLAC[TROLL]);
	MOVE(TROLL2+100,FIXD[TROLL]);
	JUGGLE(CHASM);
	PROP[TROLL]=2;
	goto L9021;

L9027:	if (OBJ==VASE & LOC!=PLAC[PILLOW]) goto L9028;
	RSPEAK(54);
	goto L9021;

L9028:	PROP[VASE]=2;
	if (AT(PILLOW)) PROP[VASE]=0;
	PSPEAK(VASE,PROP[VASE]+1);
	if (PROP[VASE]!=0) FIXED[VASE]=-1;
	goto L9021;

// SAY.  ECHO WD2 (OR WD1 IF NO WD2 (SAY WHAT?, ETC.).)  MAGIC WORDS OVERRIDE.

L9030:	CONCAT(WDSTR,WD2,WD2X);
	if (WD2==0) {
	  CONCAT(WDSTR,WD1,WD1X);
	}
	if (WD2!=0) COPY(WD1,WD2);
	I=VOCAB(WD1,-1);
	if (I==62 | I==65 | I==71 | I==2025) goto L9035;
	printf("\nOkay, \"%s\".\n",WDSTR);
	goto L2012;

L9035:	CLEAR(WD2);
	OBJ=0;
	goto L2630;


// LOCK, UNLOCK, NO OBJECT GIVEN.  ASSUME VARIOUS THINGS IF PRESENT.

L8040:	SPK=28;
	if (HERE(CLAM)) OBJ=CLAM;
	if (HERE(OYSTER)) OBJ=OYSTER;
	if (AT(DOOR)) OBJ=DOOR;
	if (AT(GRATE)) OBJ=GRATE;
	if (OBJ!=0 & HERE(CHAIN)) goto L8000;
	if (HERE(CHAIN)) OBJ=CHAIN;
	if (OBJ==0) goto L2011;

// LOCK, UNLOCK OBJECT.  SPECIAL STUFF FOR OPENING CLAM/OYSTER AND FOR CHAIN.

L9040:	if (OBJ==CLAM | OBJ==OYSTER) goto L9046;
	if (OBJ==DOOR) SPK=111;
	if (OBJ==DOOR & PROP[DOOR]==1) SPK=54;
	if (OBJ==CAGE) SPK=32;
	if (OBJ==KEYS) SPK=55;
	if (OBJ==GRATE | OBJ==CHAIN) SPK=31;
	if (SPK!=31 | !HERE(KEYS)) goto L2011;
	if (OBJ==CHAIN) goto L9048;
	if (!CLOSNG) goto L9043;
	K=130;
	if (!PANIC) CLOCK2=15;
	PANIC=true;
	goto L2010;

L9043:	K=34+PROP[GRATE];
	PROP[GRATE]=1;
	if (VERB==LOCK) PROP[GRATE]=0;
	K=K+2*PROP[GRATE];
	goto L2010;

// CLAM/OYSTER.
L9046:	K=0;
	if (OBJ==OYSTER) K=1;
	SPK=124+K;
	if (TOTING(OBJ)) SPK=120+K;
	if (!TOTING(TRIDNT)) SPK=122+K;
	if (VERB==LOCK) SPK=61;
	if (SPK!=124) goto L2011;
	DSTROY(CLAM);
	DROP(OYSTER,LOC);
	DROP(PEARL,105);
	goto L2011;

// CHAIN.
L9048:	if (VERB==LOCK) goto L9049;
	SPK=171;
	if (PROP[BEAR]==0) SPK=41;
	if (PROP[CHAIN]==0) SPK=37;
	if (SPK!=171) goto L2011;
	PROP[CHAIN]=0;
	FIXED[CHAIN]=0;
	if (PROP[BEAR]!=3) PROP[BEAR]=2;
	FIXED[BEAR]=2-PROP[BEAR];
	goto L2011;

L9049:	SPK=172;
	if (PROP[CHAIN]!=0) SPK=34;
	if (LOC!=PLAC[CHAIN]) SPK=173;
	if (SPK!=172) goto L2011;
	PROP[CHAIN]=2;
	if (TOTING(CHAIN)) DROP(CHAIN,LOC);
	FIXED[CHAIN]=-1;
	goto L2011;

// LIGHT LAMP

L9070:	if (!HERE(LAMP)) goto L2011;
	SPK=184;
	if (LIMIT<0) goto L2011;
	PROP[LAMP]=1;
	RSPEAK(39);
	if (WZDARK) goto L2000;
	goto L2012;

// LAMP OFF

L9080:	if (!HERE(LAMP)) goto L2011;
	PROP[LAMP]=0;
	RSPEAK(40);
	if (DARK(0)) RSPEAK(16);
	goto L2012;

// WAVE.  NO EFFECT UNLESS WAVING ROD AT FISSURE.

L9090:	if ((!TOTING(OBJ)) & (OBJ!=ROD | !TOTING(ROD2))) SPK=29;
	if (OBJ!=ROD | !AT(FISSUR) | !TOTING(OBJ) | CLOSNG) goto L2011;
	PROP[FISSUR]=1-PROP[FISSUR];
	PSPEAK(FISSUR,2-PROP[FISSUR]);
	goto L2012;

// ATTACK.  ASSUME TARGET IF UNAMBIGUOUS.  "THROW" ALSO LINKS HERE.  ATTACKABLE
// OBJECTS FALL INTO TWO CATEGORIES: ENEMIES (SNAKE, DWARF, ETC.)  AND OTHERS
// (BIRD, CLAM).  AMBIGUOUS IF TWO ENEMIES, OR IF NO ENEMIES BUT TWO OTHERS.

L9120:	for (I=1; I<=5; I++) {
	  if (DLOC[I]==LOC & DFLAG>=2) goto L9122;
	}
	I=0;
L9122:	if (OBJ!=0) goto L9124;
	if (I!=0) OBJ=DWARF;
	if (HERE(SNAKE)) OBJ=OBJ*100+SNAKE;
	if (AT(DRAGON) & PROP[DRAGON]==0) OBJ=OBJ*100+DRAGON;
	if (AT(TROLL)) OBJ=OBJ*100+TROLL;
	if (HERE(BEAR) & PROP[BEAR]==0) OBJ=OBJ*100+BEAR;
	if (OBJ>100) goto L8000;
	if (OBJ!=0) goto L9124;
// CAN'T ATTACK BIRD BY THROWING AXE.
	if (HERE(BIRD) & VERB!=THROW) OBJ=BIRD;
// CLAM AND OYSTER BOTH TREATED AS CLAM FOR INTRANSITIVE CASE; NO HARM DONE.
	if (HERE(CLAM) | HERE(OYSTER)) OBJ=100*OBJ+CLAM;
	if (OBJ>100) goto L8000;
L9124:	if (OBJ!=BIRD) goto L9125;
	SPK=137;
	if (CLOSED) goto L2011;
	DSTROY(BIRD);
	PROP[BIRD]=0;
	if (PLACE[SNAKE]==PLAC[SNAKE]) TALLY2=TALLY2+1;
	SPK=45;
L9125:	if (OBJ==0) SPK=44;
	if (OBJ==CLAM | OBJ==OYSTER) SPK=150;
	if (OBJ==SNAKE) SPK=46;
	if (OBJ==DWARF) SPK=49;
	if (OBJ==DWARF & CLOSED) goto L19000;
	if (OBJ==DRAGON) SPK=167;
	if (OBJ==TROLL) SPK=157;
	if (OBJ==BEAR) SPK=165+(PROP[BEAR]+1)/2;
	if (OBJ!=DRAGON | PROP[DRAGON]!=0) goto L2011;
// FUN STUFF FOR DRAGON.  IF HE INSISTS ON ATTACKING IT, WIN!  SET PROP TO 
// DEAD, MOVE DRAGON TO CENTRAL LOC (STILL FIXED), MOVE RUG THERE (NOT FIXED),
// AND MOVE HIM THERE, TOO.  THEN DO A NULL MOTION TO GET NEW DESCRIPTION.
	RSPEAK(49);
	VERB=0;
	OBJ=0;
	GETIN(WD1,WD1X,WD2,WD2X);
	if (!MATCH(WD1,"Y") & !MATCH(WD1,"YES")) goto L2608;
	PSPEAK(DRAGON,1);
	PROP[DRAGON]=2;
	PROP[RUG]=0;
	K=(PLAC[DRAGON]+FIXD[DRAGON])/2;
	MOVE(DRAGON+100,-1);
	MOVE(RUG+100,0);
	MOVE(DRAGON,K);
	MOVE(RUG,K);
	for (OBJ=1; OBJ<OBJSIZ; OBJ++) {
	  if (PLACE[OBJ]==PLAC[DRAGON] | PLACE[OBJ]==FIXD[DRAGON]) {
	    MOVE(OBJ,K);
	  }
	}
	LOC=K;
	K=NUL;
	goto L8;

// POUR.  IF NO OBJECT, OR OBJECT IS BOTTLE, ASSUME CONTENTS OF BOTTLE.
// SPECIAL TESTS FOR POURING WATER OR OIL ON PLANT OR RUSTY DOOR.

L9130:	if (OBJ==BOTTLE | OBJ==0) OBJ=LIQ(0);
	if (OBJ==0) goto L8000;
	if (!TOTING(OBJ)) goto L2011;
	SPK=78;
	if (OBJ!=OIL & OBJ!=WATER) goto L2011;
	PROP[BOTTLE]=1;
	PLACE[OBJ]=0;
	SPK=77;
	if (!(AT(PLANT) | AT(DOOR))) goto L2011;

	if (AT(DOOR)) goto L9132;
	SPK=112;
	if (OBJ!=WATER) goto L2011;
	PSPEAK(PLANT,PROP[PLANT]+1);
	PROP[PLANT]=MOD(PROP[PLANT]+2,6);
	PROP[PLANT2]=PROP[PLANT]/2;
	K=NUL;
	goto L8;

L9132:	PROP[DOOR]=0;
	if (OBJ==OIL) PROP[DOOR]=1;
	SPK=113+PROP[DOOR];
	goto L2011;

// EAT.  INTRANSITIVE: ASSUME FOOD IF PRESENT, ELSE ASK WHAT.  TRANSITIVE: FOOD
// OK, SOME THINGS LOSE APPETITE, REST ARE RIDICULOUS.

L8140:	if (!HERE(FOOD)) goto L8000;
L8142:	DSTROY(FOOD);
	SPK=72;
	goto L2011;

L9140:	if (OBJ==FOOD) goto L8142;
	if (OBJ==BIRD || OBJ==SNAKE || OBJ==CLAM || OBJ==OYSTER ||
	       OBJ==DWARF || OBJ==DRAGON || OBJ==TROLL || OBJ==BEAR) SPK=71;
	goto L2011;

// DRINK.  IF NO OBJECT, ASSUME WATER AND LOOK FOR IT HERE.  IF WATER IS IN
// THE BOTTLE, DRINK THAT, ELSE MUST BE AT A WATER LOC, SO DRINK STREAM.

L9150:	if (OBJ==0 & LIQLOC(LOC)!=WATER & (LIQ(0)!=WATER | !HERE(BOTTLE))) 
            goto L8000;
	if (OBJ!=0 & OBJ!=WATER) SPK=110;
	if (SPK==110 | LIQ(0)!=WATER | !HERE(BOTTLE)) goto L2011;
	PROP[BOTTLE]=1;
	PLACE[WATER]=0;
	SPK=74;
	goto L2011;

// RUB.  YIELDS VARIOUS SNIDE REMARKS.

L9160:	if (OBJ!=LAMP) SPK=76;
	goto L2011;

// THROW.  SAME AS DISCARD UNLESS AXE.  THEN SAME AS ATTACK EXCEPT IGNORE BIRD,
// AND IF DWARF IS PRESENT THEN ONE MIGHT BE KILLED.  (ONLY WAY TO DO SO!)
// AXE ALSO SPECIAL FOR DRAGON, BEAR, AND TROLL.  TREASURES SPECIAL FOR TROLL.

L9170:	if (TOTING(ROD2) & OBJ==ROD & !TOTING(ROD)) OBJ=ROD2;
	if (!TOTING(OBJ)) goto L2011;
	if (OBJ>=50 & OBJ<=MAXTRS & AT(TROLL)) goto L9178;
	if (OBJ==FOOD & HERE(BEAR)) goto L9177;
	if (OBJ!=AXE) goto L9020;
	for (I=1; I<=5; I++) {
// NEEDN'T CHECK DFLAG IF AXE IS HERE.
	  if (DLOC[I]==LOC) goto L9172;
	}
	SPK=152;
	if (AT(DRAGON) & PROP[DRAGON]==0) goto L9175;
	SPK=158;
	if (AT(TROLL)) goto L9175;
	if (HERE(BEAR) & PROP[BEAR]==0) goto L9176;
	OBJ=0;
	goto L9120;

L9172:	SPK=48;
// IF SAVED NOT = -1, HE BYPASSED THE "START" CALL.
	if (RAN(3)==0 | SAVED!=-1) goto L9175;
	DSEEN[I]=false;
	DLOC[I]=0;
	SPK=47;
	DKILL=DKILL+1;
	if (DKILL==1) SPK=149;
L9175:	RSPEAK(SPK);
	DROP(AXE,LOC);
	K=NUL;
	goto L8;

// THIS'LL TEACH HIM TO THROW THE AXE AT THE BEAR!
L9176:	SPK=164;
	DROP(AXE,LOC);
	FIXED[AXE]=-1;
	PROP[AXE]=1;
	JUGGLE(BEAR);
	goto L2011;

// BUT THROWING FOOD IS ANOTHER STORY.
L9177:	OBJ=BEAR;
	goto L9210;

L9178:	SPK=159;
// SNARF A TREASURE FOR THE TROLL.
	DROP(OBJ,0);
	MOVE(TROLL,0);
	MOVE(TROLL+100,0);
	DROP(TROLL2,PLAC[TROLL]);
	DROP(TROLL2+100,FIXD[TROLL]);
	JUGGLE(CHASM);
	goto L2011;

// QUIT.  INTRANSITIVE ONLY.  VERIFY INTENT AND EXIT IF THAT'S WHAT HE WANTS.

L8180:	GAVEUP=YES(22,54,54);
L8185:	if (GAVEUP) goto L20000;
	goto L2012;

// FIND.  MIGHT BE CARRYING IT, OR IT MIGHT BE HERE.  ELSE GIVE CAVEAT.

L9190:	if (AT(OBJ) | (LIQ(0)==OBJ & AT(BOTTLE)) | K==LIQLOC(LOC)) SPK=94;
	for (I=1; I<=5; I++) if (DLOC[I]==LOC & DFLAG>=2 & OBJ==DWARF) SPK=94;
	if (CLOSED) SPK=138;
	if (TOTING(OBJ)) SPK=24;
	goto L2011;

// INVENTORY.  IF OBJECT, TREAT SAME AS FIND.  ELSE REPORT ON CURRENT BURDEN.

L8200:	SPK=98;
	for (I=1; I<OBJSIZ; I++) {
	  if (I==BEAR | !TOTING(I)) continue;
	  if (SPK==98) RSPEAK(99);
	  BLKLIN=false;
	  PSPEAK(I,-1);
	  BLKLIN=true;
	  SPK=0;
	}
	if (TOTING(BEAR)) SPK=141;
	goto L2011;

// FEED.  IF BIRD, NO SEED.  SNAKE, DRAGON, TROLL: QUIP.  IF DWARF, MAKE HIM
// MAD.  BEAR, SPECIAL.

L9210:	if (OBJ!=BIRD) goto L9212;
	SPK=100;
	goto L2011;

L9212:	if (OBJ!=SNAKE & OBJ!=DRAGON & OBJ!=TROLL) goto L9213;
	SPK=102;
	if (OBJ==DRAGON & PROP[DRAGON]!=0) SPK=110;
	if (OBJ==TROLL) SPK=182;
	if (OBJ!=SNAKE | CLOSED | !HERE(BIRD)) goto L2011;
	SPK=101;
	DSTROY(BIRD);
	PROP[BIRD]=0;
	TALLY2=TALLY2+1;
	goto L2011;

L9213:	if (OBJ!=DWARF) goto L9214;
	if (!HERE(FOOD)) goto L2011;
	SPK=103;
	DFLAG=DFLAG+1;
	goto L2011;

L9214:	if (OBJ!=BEAR) goto L9215;
	if (PROP[BEAR]==0) SPK=102;
	if (PROP[BEAR]==3) SPK=110;
	if (!HERE(FOOD)) goto L2011;
	DSTROY(FOOD);
	PROP[BEAR]=1;
	FIXED[AXE]=0;
	PROP[AXE]=0;
	SPK=168;
	goto L2011;

L9215:	SPK=14;
	goto L2011;

// FILL.  BOTTLE MUST BE EMPTY, AND SOME LIQUID AVAILABLE.  (VASE IS NASTY.)

L9220:	if (OBJ==VASE) goto L9222;
	if (OBJ!=0 & OBJ!=BOTTLE) goto L2011;
	if (OBJ==0 & !HERE(BOTTLE)) goto L8000;
	SPK=107;
	if (LIQLOC(LOC)==0) SPK=106;
	if (LIQ(0)!=0) SPK=105;
	if (SPK!=107) goto L2011;
	PROP[BOTTLE]=MOD(COND[LOC],4)/2*2;
	K=LIQ(0);
	if (TOTING(BOTTLE)) PLACE[K]=-1;
	if (K==OIL) SPK=108;
	goto L2011;

L9222:	SPK=29;
	if (LIQLOC(LOC)==0) SPK=144;
	if (LIQLOC(LOC)==0 | !TOTING(VASE)) goto L2011;
	RSPEAK(145);
	PROP[VASE]=2;
	FIXED[VASE]=-1;
	goto L9024;

// BLAST.  NO EFFECT UNLESS YOU'VE GOT DYNAMITE, WHICH IS A NEAT TRICK!

L9230:	if (PROP[ROD2]<0 | !CLOSED) goto L2011;
	BONUS=133;
	if (LOC==115) BONUS=134;
	if (HERE(ROD2)) BONUS=135;
	RSPEAK(BONUS);
	goto L20000;

// SCORE.  GO TO SCORING SECTION, WHICH WILL RETURN TO 8241 IF SCORNG IS TRUE.

L8240:	SCORNG=true;
	goto L20000;

L8241:	SCORNG=false;
	printf("\nIf you were to quit now, you would score %d"
               " out of a possible %d.\n", SCORE, MXSCOR);
	GAVEUP=YES(143,54,54);
	goto L8185;

// FEE FIE FOE FOO (AND FUM).  ADVANCE TO NEXT STATE IF GIVEN IN PROPER ORDER.
// LOOK UP WD1 IN SECTION 3 OF VOCAB TO DETERMINE WHICH WORD WE'VE GOT.  LAST
// WORD ZIPS THE EGGS BACK TO THE GIANT ROOM (UNLESS ALREADY THERE).

L8250:	K=VOCAB(WD1,3);
	SPK=42;
	if (FOOBAR==1-K) goto L8252;
	if (FOOBAR!=0) SPK=151;
	goto L2011;

L8252:	FOOBAR=K;
	if (K!=4) goto L2009;
	FOOBAR=0;
	if (PLACE[EGGS]==PLAC[EGGS] | (TOTING(EGGS) & LOC==PLAC[EGGS])) {
	  goto L2011;
	}
// BRING BACK TROLL IF WE STEAL THE EGGS BACK FROM HIM BEFORE CROSSING.
	if (PLACE[EGGS]==0 & PLACE[TROLL]==0 & PROP[TROLL]==0) PROP[TROLL]=1;
	K=2;
	if (HERE(EGGS)) K=1;
	if (LOC==PLAC[EGGS]) K=0;
	MOVE(EGGS,PLAC[EGGS]);
	PSPEAK(EGGS,K);
	goto L2012;

// BRIEF.  INTRANSITIVE ONLY.  SUPPRESS LONG DESCRIPTIONS AFTER FIRST TIME.

L8260:	SPK=156;
	ABBNUM=10000;
	DETAIL=3;
	goto L2011;

// READ.  MAGAZINES IN DWARVISH, MESSAGE WE'VE SEEN, AND . . . OYSTER?

L8270:	if (HERE(MAGZIN)) OBJ=MAGZIN;
	if (HERE(TABLET)) OBJ=OBJ*100+TABLET;
	if (HERE(MESSAG)) OBJ=OBJ*100+MESSAG;
	if (CLOSED & TOTING(OYSTER)) OBJ=OYSTER;
	if (OBJ>100 | OBJ==0 | DARK(0)) goto L8000;

L9270:	if (DARK(0)) goto L5190;  // would be better to add: | !HERE(OBJ)
	if (OBJ==MAGZIN) SPK=190;
	if (OBJ==TABLET) SPK=196;
	if (OBJ==MESSAG) SPK=191;
	if (OBJ==OYSTER & HINTED[2] & TOTING(OYSTER)) SPK=194;
	if (OBJ!=OYSTER | HINTED[2] | !TOTING(OYSTER) | !CLOSED) goto L2011;
	HINTED[2]=YES(192,193,54);
	goto L2012;

// BREAK.  ONLY WORKS FOR MIRROR IN REPOSITORY AND, OF COURSE, THE VASE.

L9280:	if (OBJ==MIRROR) SPK=148;
	if (OBJ==VASE & PROP[VASE]==0) goto L9282;
	if (OBJ!=MIRROR | !CLOSED) goto L2011;
	RSPEAK(197);
	goto L19000;

L9282:	SPK=198;
	if (TOTING(VASE)) DROP(VASE,LOC);
	PROP[VASE]=2;
	FIXED[VASE]=-1;
	goto L2011;

// WAKE.  ONLY USE IS TO DISTURB THE DWARVES.

L9290:	if (OBJ!=DWARF | !CLOSED) goto L2011;
	RSPEAK(199);
	goto L19000;

// SUSPEND.  OFFER TO EXIT LEAVING THINGS RESTARTABLE, BUT REQUIRING A DELAY
// BEFORE RESTARTING (SO CAN'T SAVE THE WORLD BEFORE TRYING SOMETHING RISKY).
// UPON RESTARTING, SETUP=-1 CAUSES RETURN TO 8305 TO PICK UP AGAIN.

L8300: SPK=201;
	//if (DEMO) goto L2011;
	printf("\nI can suspend your adventure for you so that you can "
	       "resume later, but\nyou will have to wait at least %d "
	       "minutes before continuing.\n", LATNCY);
	if (!YES(200,54,54)) goto L2012;

	fp = fopen(savename(), "w");
	if (fp == NULL) {
	  perror("Unable to open file");
	  goto L2012;
	}
	beg = (char*) &BEGSTATE;
	end = (char*) &ENDSTATE;
	if (beg > end) {
	  end = (char*) &BEGSTATE;
	  beg = (char*) &ENDSTATE;
	}
	BEGSTATE = time(NULL);
	fwrite(beg, 1, end - beg, fp);
#ifdef DEBUG
	printf("State beg: %08x  size: %d  time: %d\n", 
	                (unsigned)beg, (int)(end - beg), (int)BEGSTATE);
#endif
	fclose(fp);
	putchar('\n');
	exit(0);

#ifdef OLDSUSPEND
	DATIME(SAVED,SAVET);
	SETUP=-1;
	CIAO;

L8305:	YEA=START(0);
	SETUP=3;
	K=NUL;
	goto L8;
#endif

// HOURS.  REPORT CURRENT NON-PRIME-TIME HOURS.

//L8310:	MSPEAK(6);
//	HOURS;
//	goto L2012;

L8310:	printf("\nThis version is open 24 hours, 7 days a week.\n");
	goto L2012;




// HINTS;

// COME HERE IF HE'S BEEN LONG ENOUGH AT REQUIRED LOC(S) FOR SOME UNUSED HINT.
// HINT NUMBER IS IN VARIABLE "HINT".  BRANCH TO QUICK TEST FOR ADDITIONAL
// CONDITIONS, THEN COME BACK TO DO NEAT STUFF.  goto L40010 IF CONDITIONS ARE
// MET AND WE WANT TO OFFER THE HINT.  GOTO 40020 TO CLEAR HINTL//BACK TO ZERO,
// 40030 TO TAKE NO ACTION YET.

L40000:	switch (HINT-3) {
	  case 1: goto L40400;   // CAVE
	  case 2: goto L40500;   // BIRD
	  case 3: goto L40600;   // SNAKE
	  case 4: goto L40700;   // MAZE
	  case 5: goto L40800;   // DARK
	  case 6: goto L40900;   // WITT'S END
	}
	BUG(27);

L40010:	HINTLC[HINT]=0;
	if (!YES(HINTS[HINT].QSTN,0,54)) goto L2602;
	printf("\nI am prepared to give you a hint, "
                       "but it will cost you %d points.\n", HINTS[HINT].PNTS);
	HINTED[HINT]=YES(175,HINTS[HINT].HINT,54);
	if (HINTED[HINT] & LIMIT>30) LIMIT=LIMIT+30*HINTS[HINT].TRNS;
L40020:	HINTLC[HINT]=0;
L40030:	goto L2602;

// NOW FOR THE QUICK TESTS.  SEE DATABASE DESCRIPTION FOR ONE-LINE NOTES.

L40400:	if (PROP[GRATE]==0 & !HERE(KEYS)) goto L40010;
	goto L40020;

L40500:	if (HERE(BIRD) & TOTING(ROD) & OBJ==BIRD) goto L40010;
	goto L40030;

L40600:	if (HERE(SNAKE) & !HERE(BIRD)) goto L40010;
	goto L40020;

L40700:	if (ATLOC[LOC]==0 & ATLOC[OLDLOC]==0 & ATLOC[OLDLC2]==0 & HOLDNG>1) {
           goto L40010;
	}
	goto L40020;

L40800:	if (PROP[EMRALD]!=-1 & PROP[PYRAM]==-1) goto L40010;
	goto L40020;

L40900:	goto L40010;



// CAVE CLOSING AND SCORING

// THESE SECTIONS HANDLE THE CLOSING OF THE CAVE.  THE CAVE CLOSES "CLOCK1"
// TURNS AFTER THE LAST TREASURE HAS BEEN LOCATED (INCLUDING THE PIRATE'S
// CHEST, WHICH MAY OF COURSE NEVER SHOW UP).  NOTE THAT THE TREASURES NEED NOT
// HAVE BEEN TAKEN YET, JUST LOCATED.  HENCE CLOCK1 MUST BE LARGE ENOUGH TO GET
// OUT OF THE CAVE (IT ONLY TICKS WHILE INSIDE THE CAVE).  WHEN IT HITS ZERO,
// WE BRANCH TO 10000 TO START CLOSING THE CAVE, AND THEN SIT BACK AND WAIT FOR
// HIM TO TRY TO GET OUT.  IF HE DOESN'T WITHIN CLOCK2 TURNS, WE CLOSE THE
// CAVE; IF HE DOES TRY, WE ASSUME HE PANICS, AND GIVE HIM A FEW ADDITIONAL
// TURNS TO GET FRANTI//BEFORE WE CLOSE.  WHEN CLOCK2 HITS ZERO, WE BRANCH TO
// 11000 TO TRANSPORT HIM INTO THE FINAL PUZZLE.  NOTE THAT THE PUZZLE DEPENDS
// UPON ALL SORTS OF RANDOM THINGS.  FOR INSTANCE, THERE MUST BE NO WATER OR
// OIL, SINCE THERE ARE BEANSTALKS WHICH WE DON'T WANT TO BE ABLE TO WATER,
// SINCE THE CODE CAN'T HANDLE IT.  ALSO, WE CAN HAVE NO KEYS, SINCE THERE IS A
// GRATE (HAVING MOVED THE FIXED OBJECT!) THERE SEPARATING HIM FROM ALL THE
// TREASURES.  MOST OF THESE PROBLEMS ARISE FROM THE USE OF NEGATIVE PROP
// NUMBERS TO SUPPRESS THE OBJECT DESCRIPTIONS UNTIL HE'S ACTUALLY MOVED THE
// OBJECTS.

// WHEN THE FIRST WARNING COMES, WE LOCK THE GRATE, DESTROY THE BRIDGE, KILL
// ALL THE DWARVES (AND THE PIRATE), REMOVE THE TROLL AND BEAR (UNLESS DEAD),
// AND SET "CLOSNG" TO TRUE.  LEAVE THE DRAGON; TOO MUCH TROUBLE TO MOVE IT.
// FROM NOW UNTIL CLOCK2 RUNS OUT, HE CANNOT UNLOCK THE GRATE, MOVE TO ANY
// LOCATION OUTSIDE THE CAVE (LOC<9), OR CREATE THE BRIDGE.  NOR CAN HE BE
// RESURRECTED IF HE DIES.  NOTE THAT THE SNAKE IS ALREADY GONE, SINCE HE GOT
// TO THE TREASURE ACCESSIBLE ONLY VIA THE HALL OF THE MT. KING.  ALSO, HE'S
// BEEN IN GIANT ROOM (TO GET EGGS), SO WE CAN REFER TO IT.  ALSO ALSO, HE'S
// GOTTEN THE PEARL, SO WE KNOW THE BIVALVE IS AN OYSTER.  *AND*, THE DWARVES
// MUST HAVE BEEN ACTIVATED, SINCE WE'VE FOUND CHEST.

L10000:	PROP[GRATE]=0;
	PROP[FISSUR]=0;
	for (I=1; I<=6; I++) {
	  DSEEN[I]=false;
	  DLOC[I]=0;
	}
	MOVE(TROLL,0);
	MOVE(TROLL+100,0);
	MOVE(TROLL2,PLAC[TROLL]);
	MOVE(TROLL2+100,FIXD[TROLL]);
	JUGGLE(CHASM);
	if (PROP[BEAR]!=3) DSTROY(BEAR);
	PROP[CHAIN]=0;
	FIXED[CHAIN]=0;
	PROP[AXE]=0;
	FIXED[AXE]=0;
	RSPEAK(129);
	CLOCK1=-1;
	CLOSNG=true;
	goto L19999;

// ONCE HE'S PANICKED, AND CLOCK2 HAS RUN OUT, WE COME HERE TO SET UP THE
// STORAGE ROOM.  THE ROOM HAS TWO LOCS, HARDWIRED AS 115 (NE) AND 116 (SW).
// AT THE NE END, WE PLACE EMPTY BOTTLES, A NURSERY OF PLANTS, A BED OF
// OYSTERS, A PILE OF LAMPS, RODS WITH STARS, SLEEPING DWARVES, AND HIM.  AND
// THE SW END WE PLACE GRATE OVER TREASURES, SNAKE PIT, COVEY OF CAGED BIRDS,
// MORE RODS, AND PILLOWS.  A MIRROR STRETCHES ACROSS ONE WALL.  MANY OF THE
// OBJECTS COME FROM KNOWN LOCATIONS AND/OR STATES (E.G. THE SNAKE IS KNOWN TO
// HAVE BEEN DESTROYED AND NEEDN'T BE CARRIED AWAY FROM ITS OLD "PLACE"),
// MAKING THE VARIOUS OBJECTS BE HANDLED DIFFERENTLY.  WE ALSO DROP ALL OTHER
// OBJECTS HE MIGHT BE CARRYING (LEST HE HAVE SOME WHICH COULD CAUSE TROUBLE,
// SUCH AS THE KEYS).  WE DESCRIBE THE FLASH OF LIGHT AND TRUNDLE BACK.

L11000:	PROP[BOTTLE]=PUT(BOTTLE,115,1);
	PROP[PLANT]=PUT(PLANT,115,0);
	PROP[OYSTER]=PUT(OYSTER,115,0);
	PROP[LAMP]=PUT(LAMP,115,0);
	PROP[ROD]=PUT(ROD,115,0);
	PROP[DWARF]=PUT(DWARF,115,0);
	LOC=115;
	OLDLOC=115;
	NEWLOC=115;

// LEAVE THE GRATE WITH NORMAL (NON-NEGATIVE PROPERTY).

	PUT(GRATE,116,0);
	PROP[SNAKE]=PUT(SNAKE,116,1);
	PROP[BIRD]=PUT(BIRD,116,1);
	PROP[CAGE]=PUT(CAGE,116,0);
	PROP[ROD2]=PUT(ROD2,116,0);
	PROP[PILLOW]=PUT(PILLOW,116,0);

	PROP[MIRROR]=PUT(MIRROR,115,0);
	FIXED[MIRROR]=116;

	for (I=1; I<OBJSIZ; I++) {
	  if (TOTING(I)) DSTROY(I);
	}

	RSPEAK(132);
	CLOSED=true;
	goto L2;

// ANOTHER WAY WE CAN FORCE AN END TO THINGS IS BY HAVING THE LAMP GIVE OUT.
// WHEN IT GETS CLOSE, WE COME HERE TO WARN HIM.  WE GO TO 12000 IF THE LAMP
// AND FRESH BATTERIES ARE HERE, IN WHICH CASE WE REPLACE THE BATTERIES AND
// CONTINUE.  12200 IS FOR OTHER CASES OF LAMP DYING.  12400 IS WHEN IT GOES
// OUT, AND 12600 IS IF HE'S WANDERED OUTSIDE AND THE LAMP IS USED UP, IN WHICH
// CASE WE FORCE HIM TO GIVE UP.

L12000:	RSPEAK(188);
	PROP[BATTER]=1;
	if (TOTING(BATTER)) DROP(BATTER,LOC);
	LIMIT=LIMIT+2500;
	LMWARN=false;
	goto L19999;

L12200:	if (LMWARN | !HERE(LAMP)) goto L19999;
	LMWARN=true;
	SPK=187;
	if (PLACE[BATTER]==0) SPK=183;
	if (PROP[BATTER]==1) SPK=189;
	RSPEAK(SPK);
	goto L19999;

L12400:	LIMIT=-1;
	PROP[LAMP]=0;
	if (HERE(LAMP)) RSPEAK(184);
	goto L19999;

L12600:	RSPEAK(185);
	GAVEUP=true;
	goto L20000;

// AND, OF COURSE, DEMO GAMES ARE ENDED BY THE WIZARD.

//L13000:	MSPEAK(1);
//	goto L20000;

// OH DEAR, HE'S DISTURBED THE DWARVES.

L19000:	RSPEAK(136);

// EXIT CODE.  WILL EVENTUALLY INCLUDE SCORING.  FOR NOW, HOWEVER, ...

// THE PRESENT SCORING ALGORITHM IS AS FOLLOWS:
//    OBJECTIVE:          POINTS:        PRESENT TOTAL POSSIBLE:
// GETTING WELL INTO CAVE   25                    25
// EACH TREASURE < CHEST    12                    60
// TREASURE CHEST ITSELF    14                    14
// EACH TREASURE > CHEST    16                   144
// SURVIVING             (MAX-NUM)*10             30
// NOT QUITTING              4                     4
// REACHING "CLOSNG"        25                    25
// "CLOSED": QUIT/KILLED    10
//           KLUTZED        25
//           WRONG WAY      30
//           SUCCESS        45                    45
// CAME TO WITT'S END        1                     1
// ROUND OUT THE TOTAL       2                     2
//                                      TOTAL:   350
// (POINTS CAN ALSO BE DEDUCTED FOR USING HINTS.)

L20000:	SCORE=0;
	MXSCOR=0;

// FIRST TALLY UP THE TREASURES.  MUST BE IN BUILDING AND NOT BROKEN.
// GIVE THE POOR GUY 2 POINTS JUST FOR FINDING EACH TREASURE.

	for (I=50; I<MAXTRS; I++) {
	  if (PTEXT[I]==0) continue;
	  K=12;
	  if (I==CHEST) K=14;
	  if (I>CHEST) K=16;
	  if (PROP[I]>=0) SCORE=SCORE+2;
	  if (PLACE[I]==3 & PROP[I]==0) SCORE=SCORE+K-2;
	  MXSCOR=MXSCOR+K;
	}

// NOW LOOK AT HOW HE FINISHED AND HOW FAR HE GOT.  MAXDIE AND NUMDIE TELL US
// HOW WELL HE SURVIVED.  GAVEUP SAYS WHETHER HE EXITED VIA QUIT.  DFLAG WILL
// TELL US IF HE EVER GOT SUITABLY DEEP INTO THE CAVE.  CLOSNG STILL INDICATES
// WHETHER HE REACHED THE ENDGAME.  AND IF HE GOT AS FAR AS "CAVE CLOSED"
// (INDICATED BY "CLOSED"), THEN BONUS IS ZERO FOR MUNDANE EXITS OR 133, 134,
// 135 IF HE BLEW IT (SO TO SPEAK).

	SCORE=SCORE+(MAXDIE-NUMDIE)*10;
	MXSCOR=MXSCOR+MAXDIE*10;
	if (!(SCORNG | GAVEUP)) SCORE=SCORE+4;
	MXSCOR=MXSCOR+4;
	if (DFLAG!=0) SCORE=SCORE+25;
	MXSCOR=MXSCOR+25;
	if (CLOSNG) SCORE=SCORE+25;
	MXSCOR=MXSCOR+25;
	if (!CLOSED) goto L20020;
	if (BONUS==0) SCORE=SCORE+10;
	if (BONUS==135) SCORE=SCORE+25;
	if (BONUS==134) SCORE=SCORE+30;
	if (BONUS==133) SCORE=SCORE+45;
L20020:	MXSCOR=MXSCOR+45;

// DID HE COME TO WITT'S END AS HE SHOULD?

	if (PLACE[MAGZIN]==108) SCORE=SCORE+1;
	MXSCOR=MXSCOR+1;

// ROUND IT OFF.

	SCORE=SCORE+2;
	MXSCOR=MXSCOR+2;

// DEDUCT POINTS FOR HINTS.  HINTS < 4 ARE SPECIAL; SEE DATABASE DESCRIPTION.

	for (I=1; I<=HNTMAX; I++) if (HINTED[I]) SCORE=SCORE-HINTS[I].PNTS;

// RETURN TO SCORE COMMAND IF THAT'S WHERE WE CAME FROM.

	if (SCORNG) goto L8241;

// THAT SHOULD BE GOOD ENOUGH.  LET'S TELL HIM ALL ABOUT IT.

	printf("\nYou scored %d out of a possible %d using %d turns.",
	       SCORE,MXSCOR,TURNS);

        for (I=1; I<CLSSES; I++) {
	  if (CVAL[I]>=SCORE) goto L20210;
	}
	printf("\nYou just went off my scale!!\n\n");
	goto L25000;

L20210:	SPEAK(CTEXT[I]);
    if (I==CLSSES-1) goto L20220;
    K=CVAL[I]+1-SCORE;
    printf("To achieve the next higher rating, you need %d more point%s\n\n",
		                                        K, (K==1?".":"s."));
    goto L25000;

L20220:	printf("To achieve the next higher rating would be a neat trick!\n"
               "Congratulations!!\n\n");

L25000: return 0;
}

// I/O ROUTINES (SPEAK, PSPEAK, RSPEAK, GETIN, YES, A5TOA1)


// PRINT THE MESSAGE WHICH STARTS AT LINES(N).  PRECEDE IT WITH A BLANK LINE
// UNLESS BLKLIN IS FALSE.

void SPEAK(int N)
{
	if (N==0) return;
	if (strncmp(&LINES[N],">$<",3)==0) return;
	if (BLKLIN) putchar('\n');
	printf("%s",&LINES[N]);
}


// FIND THE SKIP+1ST MESSAGE FROM MSG AND PRINT IT.  MSG SHOULD BE THE INDEX OF
// THE INVENTORY MESSAGE FOR OBJECT.  (INVEN+N+1 MESSAGE IS PROP=N MESSAGE).

void PSPEAK(int MSG, int SKIP)
{
	int J=PTEXT[MSG];
	if (SKIP<0) goto L9;
	for (int I=0; I<=SKIP; I++) {
	  if (PINDX[++J]<0) BUG(17);
	}
L9:	SPEAK(IABS(PINDX[J]));
}

// PRINT THE I-TH "RANDOM" MESSAGE (SECTION 6 OF DATABASE).

void RSPEAK(int I)
{
	if (I!=0) SPEAK(RTEXT[I]);
}


// PRINT THE I-TH "MAGIC" MESSAGE (SECTION 12 OF DATABASE).

void MSPEAK(int I)
{
	if (I!=0) SPEAK(MTEXT[I]);
}


// GET A COMMAND FROM THE ADVENTURER.  SNARF OUT THE FIRST WORD, PAD IT WITH
// BLANKS, AND RETURN IT IN WORD1.  CHARS 6 THRU 10 ARE RETURNED IN WORD1X, IN
// CASE WE NEED TO PRINT OUT THE WHOLE WORD IN AN ERROR MESSAGE.  ANY NUMBER OF
// BLANKS MAY FOLLOW THE WORD.  IF A SECOND WORD APPEARS, IT IS RETURNED IN
// WORD2 (CHARS 6 THRU 10 IN WORD2X), ELSE WORD2 IS SET TO ZERO.

void GETIN(char WORD1[5], char WORD1X[5], char WORD2[5], char WORD2X[5])
{
	int c,i;

	if (BLKLIN) putchar('\n');
	CLEAR(WORD1);
	CLEAR(WORD1X);
	CLEAR(WORD2);
	CLEAR(WORD2X);

	printf("> ");
	fflush(stdout);

	c = getchar();
	while (c != '\n' && isspace(c)) c = getchar();
	for (i=0; i<5; i++) {
	  WORD1[i] = c;
	  c = getchar();
	  if (isspace(c)) break;
	}
	if (!isspace(c)) {
	  for (i=0; i<5; i++) {
	    WORD1X[i] = c;
	    c = getchar();
	    if (isspace(c)) break;
	  }
	}
	while (!isspace(c)) c = getchar();

	if (c != '\n') {
	  c = getchar();
	  while (c != '\n' && isspace(c)) c = getchar();
	  for (i=0; i<5; i++) {
	    WORD2[i] = c;
	    c = getchar();
	    if (isspace(c)) break;
	  }
	  if (!isspace(c)) {
	    for (i=0; i<5; i++) {
	      WORD2X[i] = c;
	      c = getchar();
	      if (isspace(c)) break;
	    }
	  }
	  while (c != '\n') c = getchar();
	}
}

// CALL YESX (BELOW) WITH MESSAGES FROM SECTION 6.

bool YES(int X, int Y, int Z)
{
	return YESX(X,Y,Z,&RSPEAK);
}

// CALL YESX (BELOW) WITH MESSAGES FROM SECTION 12.

bool YESM(int X, int Y, int Z)
{
	return YESX(X,Y,Z,&MSPEAK);
}


// PRINT MESSAGE X, WAIT FOR YES/NO ANSWER.  IF YES, PRINT Y AND LEAVE YEA
// TRUE; IF NO, PRINT Z AND LEAVE YEA FALSE.  SPK IS EITHER RSPEAK OR MSPEAK.

bool YESX(int X, int Y, int Z, void (*SPK)(int))
{
        char REPLY[5], JUNK1[5], JUNK2[5], JUNK3[5];

YESX1:	if (X!=0) (*SPK)(X);
	GETIN(REPLY,JUNK1,JUNK2,JUNK3);
	if (MATCH(REPLY, "YES") | MATCH(REPLY, "Y")) goto YESX10;
	if (MATCH(REPLY, "NO") | MATCH(REPLY, "N")) goto YESX20;
	printf("\nPlease answer the question.\n");
	goto YESX1;
YESX10:	if (Y!=0) (*SPK)(Y);
	return true;
YESX20:	if (Z!=0) (*SPK)(Z);
	return false;
}



// DATA STRUCTURE ROUTINES (VOCAB, DSTROY, JUGGLE, MOVE, PUT, CARRY, DROP);

// LOOK UP ID IN THE VOCABULARY (ATAB) AND RETURN ITS "DEFINITION" (KTAB), OR
// -1 IF NOT FOUND.  IF INIT IS POSITIVE, THIS IS AN INITIALISATION CALL 
// SETTING UP A KEYWORD VARIABLE, AND NOT FINDING IT CONSTITUTES A BUG.  IT 
// ALSO MEANS THAT ONLY KTAB VALUES WHICH TAKEN OVER 1000 EQUAL INIT MAY BE 
// CONSIDERED.  (THUS "STEPS", WHICH IS A MOTION VERB AS WELL AS AN OBJECT, 
// MAY BE LOCATED AS AN OBJECT.)  AND IT ALSO MEANS THE KTAB VALUE IS TAKEN 
// MOD 1000.

int VOCAB(char* ID, int INIT)
{
        int I;
        //HASH=ID.XOR.'PHROG';

	for (I=1; I<=TABSIZ; I++) {
	  if (KTAB[I]==-1) goto V2;
	  if (INIT<0 || KTAB[I]/1000==INIT) {
	    if (MATCH(&ATAB[I*5], ID)) goto V3;
	  }
	}
	BUG(21);

V2:	if (INIT<0) return -1;
	BUG(5);

V3:	if (INIT<0) return KTAB[I];
	return KTAB[I] % 1000;
}


// PERMANENTLY ELIMINATE "OBJECT" BY MOVING TO A NON-EXISTENT LOCATION.

void DSTROY(int OBJECT)
{
	MOVE(OBJECT,0);
}


// JUGGLE AN OBJECT BY PICKING IT UP AND PUTTING IT DOWN AGAIN, THE PURPOSE
// BEING TO GET THE OBJECT TO THE FRONT OF THE CHAIN OF THINGS AT ITS LOC.

void JUGGLE(int OBJECT)
{
	int I=PLACE[OBJECT];
	int J=FIXED[OBJECT];
	MOVE(OBJECT,I);
	MOVE(OBJECT+100,J);
}


// PLACE ANY OBJECT ANYWHERE BY PICKING IT UP AND DROPPING IT.  MAY ALREADY BE
// TOTING, IN WHICH CASE THE CARRY IS A NO-OP.  MUSTN'T PICK UP OBJECTS WHICH
// ARE NOT AT ANY LOC, SINCE CARRY WANTS TO REMOVE OBJECTS FROM ATLOC CHAINS.


void MOVE(int OBJECT, int WHERE)
{
  int FROM;

  if (OBJECT>100) {
    FROM=FIXED[OBJECT-100];
  }
  else {
    FROM=PLACE[OBJECT];
  } 
  if (FROM>0 & FROM<=300) CARRY(OBJECT,FROM);
  DROP(OBJECT,WHERE);
}


// PUT IS THE SAME AS MOVE, EXCEPT IT RETURNS A VALUE USED TO SET UP THE
// NEGATED PROP VALUES FOR THE REPOSITORY OBJECTS.

int PUT(int OBJECT, int WHERE, int PVAL)
{
	MOVE(OBJECT,WHERE);
	return (-1)-PVAL;
}


// START TOTING AN OBJECT, REMOVING IT FROM THE LIST OF THINGS AT ITS FORMER
// LOCATION.  INCR HOLDNG UNLESS IT WAS ALREADY BEING TOTED.  IF OBJECT>100
// (MOVING "FIXED" SECOND LOC), DON'T CHANGE PLACE OR HOLDNG.

void CARRY(int OBJECT, int WHERE)
{
  int TEMP;

	if (OBJECT>100) goto CARRY5;
	if (PLACE[OBJECT]==-1) return;
	PLACE[OBJECT]=-1;
	HOLDNG=HOLDNG+1;
CARRY5:	if (ATLOC[WHERE]!=OBJECT) goto CARRY6;
	ATLOC[WHERE]=LINK[OBJECT];
	return;
CARRY6:	TEMP=ATLOC[WHERE];
CARRY7:	if (LINK[TEMP]==OBJECT) goto CARRY8;
	TEMP=LINK[TEMP];
	goto CARRY7;
CARRY8:	LINK[TEMP]=LINK[OBJECT];
}


// PLACE AN OBJECT AT A GIVEN LOC, PREFIXING IT ONTO THE ATLOC LIST.  DECR
// HOLDNG IF THE OBJECT WAS BEING TOTED.

void DROP(int OBJECT, int WHERE)
{
        if (OBJECT>100) {
	  FIXED[OBJECT-100]=WHERE;
	}
	else {
	  if (PLACE[OBJECT]==-1) HOLDNG=HOLDNG-1;
	  PLACE[OBJECT]=WHERE;
	}
	if (WHERE<=0) return;
	LINK[OBJECT]=ATLOC[WHERE];
	ATLOC[WHERE]=OBJECT;
}



// WIZARDRY ROUTINES (START, MAINT, WIZARD, HOURS(X), NEWHRS(X), MOTD, POOF);


// CHECK TO SEE IF THIS IS "PRIME TIME".  IF SO, ONLY WIZARDS MAY PLAY, THOUGH
// OTHERS MAY BE ALLOWED A SHORT GAME FOR DEMONSTRATION PURPOSES.  IF SETUP<0,
// WE'RE CONTINUING FROM A SAVED GAME, SO CHECK FOR SUITABLE LATENCY.  RETURN
// TRUE IF THIS IS A DEMO GAME (VALUE IS IGNORED FOR RESTARTS).

bool START(int DUMMY)
{
  char *beg, *end;
  char buffer[4096];
  int  size;
  int  DELAY;

  FILE* fp = fopen(savename(),"r");  // see if there is a saved game

  if (fp == NULL) return false;      // nope, play it from the beginning

  size = 0;
  while (size < 4096) {
    int c = fgetc(fp);

    if (ferror(fp)) {
      perror("Error reading file");
      return false;
    }

    if (c == EOF) break;

    buffer[size++] = c;
  }
  fclose(fp);

#ifdef DEBUG
  printf("File size: %d  time: %d\n", size, *(int*)buffer);
#endif

  printf("\nFound a game saved on %s", ctime((time_t*)buffer));

  if (!YES(202,0,0)) return false;

  DELAY = (time(NULL) - *(time_t*)buffer) / 60;
  if (DELAY < LATNCY) {
    if (DELAY < 2) {
      printf("\nThis adventure was suspended less than 2 minutes ago.\n");
    }
    else {
      printf("\nThis adventure was suspended a mere %d minutes ago.\n", DELAY);
    }
    MSPEAK(9);
    putchar('\n');
    exit(0);
  }

  beg = (char*) &BEGSTATE;
  end = (char*) &ENDSTATE;
  if (beg > end) {
    end = (char*) &BEGSTATE;
    beg = (char*) &ENDSTATE;
  }

  if (size != end - beg) {
    printf("\nSorry, the saved file is the wrong size and cannot be restored.\n");
    return false;
  }

  memcpy(&BEGSTATE, buffer, size);

  return true;
}

#ifdef OLDSTART
	IMPLICIT INTEGER(A-Z);
	LOGICAL PTIME,SOON,YESM;
	DIMENSION HNAME(4);
	COMMON /WIZCOM/ WKDAY,WKEND,HOLID,HBEGIN,HEND,HNAME,;
		SHORT,MAGIC,MAGNM,LATNCY,SAVED,SAVET,SETUP;

// FIRST FIND OUT WHETHER IT IS PRIME TIME (SAVE IN PTIME) AND, IF RESTARTING,
// WHETHER IT'S TOO SOON (SAVE IN SOON).  PRIME-TIME SPECS ARE IN WKDAY, WKEND,
// AND HOLID; SEE MAINT ROUTINE FOR DETAILS.  LATNCY IS REQUIRED DELAY BEFORE
// RESTARTING.  WIZARDS MAY CUT THIS TO A THIRD.

	DATIME(D,T);
	PRIMTM=WKDAY;
	if (MOD(D,7)<=1)PRIMTM=WKEND;
	if (D>=HBEGIN & D<=HEND)PRIMTM=HOLID;
	PTIME=(PRIMTM & SHIFT(1,T/60))!=0;
	SOON=false;
	if (SETUP>=0) goto L20;
	DELAY=(D-SAVED)*1440+(T-SAVET);
	if (DELAY>=LATNCY) goto L20;
	TYPE 10,DELAY;
L10:	FORMAT(' This adventure was suspended a mere',I3,' minutes ago.');
	SOON=true;
	if (DELAY>=LATNCY/3) goto L20;
	MSPEAK(2);
	STOP;

// IF NEITHER TOO SOON NOR PRIME TIME, NO PROBLEM.  ELSE SPECIFY WHAT'S WRONG.

L20:	START=false;
	if (SOON) goto L30;
	if (PTIME) goto L25;
L22:	SAVED=-1;
	RETURN;

// COME HERE IF NOT RESTARTING TOO SOON (MAYBE NOT RESTARTING AT ALL), BUT IT'S
// PRIME TIME.  GIVE OUR HOURS AND SEE IF HE'S A WIZARD.  IF NOT, THEN CAN'T
// RESTART, BUT IF JUST BEGINNING THEN WE CAN OFFER A SHORT GAME.

L25:	MSPEAK(3);
	HOURS;
	MSPEAK(4);
	if (WIZARD(0)) goto L22;
	if (SETUP<0) goto L33;
	START=YESM(5,7,7);
	if (START) goto L22;
	STOP ;

// COME HERE IF RESTARTING TOO SOON.  IF HE'S A WIZARD, LET HIM GO (AND NOTE
// THAT IT THEN DOESN'T MATTER WHETHER IT'S PRIME TIME).  ELSE, TOUGH BEANS.

L30:	MSPEAK(8);
	if (WIZARD(0)) goto L22;
L33:	MSPEAK(9);
	STOP;
	END;
#endif


// SOMEONE SAID THE MAGIC WORD TO INVOKE MAINTENANCE MODE.  MAKE SURE HE'S A
// WIZARD.  IF SO, LET HIM TWEAK ALL SORTS OF RANDOM THINGS, THEN EXIT SO CAN
// SAVE TWEAKED VERSION.  SINCE MAGIC WORD MUST BE FIRST COMMAND GIVEN, ONLY
// THING WHICH NEEDS TO BE FIXED UP IS ABB(1).

#ifdef WIZARDRY
	SUBROUTINE MAINT;

	IMPLICIT INTEGER(A-Z);
	LOGICAL YESM,BLKLIN;
	DIMENSION HNAME(4),ABB(150);
	COMMON /BLKCOM/ BLKLIN;
	COMMON /ABBCOM/ ABB;
	COMMON /WIZCOM/ WKDAY,WKEND,HOLID,HBEGIN,HEND,HNAME,;
		SHORT,MAGIC,MAGNM,LATNCY,SAVED,SAVET,SETUP;

	if (!WIZARD(0))RETURN;
	BLKLIN=false;
	if (YESM(10,0,0)) HOURS;
	if (YESM(11,0,0)) NEWHRS;
	if (!YESM(26,0,0)) goto L10;
	MSPEAK(27);
	ACCEPT 1,HBEGIN;
L1:	FORMAT(G);
	MSPEAK(28);
	ACCEPT 1,HEND;
	DATIME(D,T);
	HBEGIN=HBEGIN+D;
	HEND=HBEGIN+HEND-1;
	MSPEAK(29);
	ACCEPT 2,HNAME;
L2:	FORMAT(4A5);
L10:	TYPE 12,SHORT;
L12:	FORMAT(' Length of short game (null to leave at',I3,'):');
	ACCEPT 1,X;
	if (X>0)SHORT=X;
	MSPEAK(12);
	GETIN(X,Y,Y,Y);
	if (X!=' ')MAGIC=X;
	MSPEAK(13);
	ACCEPT 1,X;
	if (X>0)MAGNM=X;
	TYPE 16,LATNCY;
L16:	FORMAT(' Latency for restart (null to leave at',I3,'):');
	ACCEPT 1,X;
	if (X>0 & X<45) MSPEAK(30);
	if (X>0)LATNCY=MAX0(45,X);
	if (YESM(14,0,0)) MOTD(true);
	SAVED=0;
	SETUP=2;
	ABB(1)=0;
	MSPEAK(15);
	BLKLIN=true;
	CIAO;
	END;
#endif


// ASK IF HE'S A WIZARD.  IF HE SAYS YES, MAKE HIM PROVE IT.  RETURN TRUE IF HE
// REALLY IS A WIZARD.

#ifdef WIZARDRY
	LOGICAL FUNCTION WIZARD(DUMMY);

	IMPLICIT INTEGER(A-Z);
	LOGICAL YESM;
	DIMENSION HNAME(4),VAL(5);
	COMMON /WIZCOM/ WKDAY,WKEND,HOLID,HBEGIN,HEND,HNAME,;
		SHORT,MAGIC,MAGNM,LATNCY,SAVED,SAVET,SETUP;

	WIZARD=YESM(16,0,7);
	if (!WIZARD)RETURN;

// HE SAYS HE IS.  FIRST STEP: DOES HE KNOW ANYTHING MAGICAL?

	MSPEAK(17);
	GETIN(WORD,X,Y,Z);
	if (WORD!=MAGIC) goto L99;

// HE DOES.  GIVE HIM A RANDOM CHALLENGE AND CHECK HIS REPLY.

	DATIME(D,T);
	T=T*2+1;
	WORD='@@@@@';
	DO 15 Y=1,5;
	X=79+MOD(D,5);
	D=D/5;
	DO 12 Z=1,X;
L12:	T=MOD(T*1027,1048576);
	VAL(Y)=(T*26)/1048576+1;
L15:	WORD=WORD+SHIFT(VAL(Y),36-7*Y);
	if (YESM(18,0,0)) goto L99;
	TYPE 18,WORD;
L18:	FORMAT(/1X,A5);
	GETIN(WORD,X,Y,Z);
	DATIME(D,T);
	T=(T/60)*40+(T/10)*10;
	D=MAGNM;
	DO 19 Y=1,5;
	Z=MOD(Y,5)+1;
	X=MOD(IABS(VAL(Y)-VAL(Z))*MOD(D,10)+MOD(T,10),26)+1;
	T=T/10;
	D=D/10;
L19:	WORD=WORD-SHIFT(X,36-7*Y);
	if (WORD!='@@@@@') goto L99;

// BY GEORGE, HE REALLY *IS* A WIZARD!

	MSPEAK(19);
	RETURN;

// AHA!  AN IMPOSTOR!

L99:	MSPEAK(20);
	WIZARD=false;
	RETURN;
	END;
#endif


// ANNOUNCE THE CURRENT HOURS WHEN THE CAVE IS OPEN FOR ADVENTURING.  THIS INFO
// IS STORED IN WKDAY, WKEND, AND HOLID, WHERE BIT SHIFT(1,N) IS ON IFF THE
// HOUR FROM N:00 TO N:59 IS "PRIME TIME" (CAVE CLOSED).  WKDAY IS FOR
// WEEKDAYS, WKEND FOR WEEKENDS, HOLID FOR HOLIDAYS.  NEXT HOLIDAY IS FROM
// HBEGIN TO HEND.
#ifdef WIZARDRY

	SUBROUTINE HOURS;

	IMPLICIT INTEGER(A-Z);
	DIMENSION HNAME(4),VAL(5);
	COMMON /WIZCOM/ WKDAY,WKEND,HOLID,HBEGIN,HEND,HNAME;

	TYPE 1;
L1:	FORMAT();
	HOURSX(WKDAY,'Mon -',' Fri:');
	HOURSX(WKEND,'Sat -',' Sun:');
	HOURSX(Holid,'Holid','ays: ');
	DATIME(D,T);
	if (HEND<D | HEND<HBEGIN)RETURN;
	if (HBEGIN>D) goto L10;
	TYPE 5,HNAME;
L5:	FORMAT(/' Today is a holiday, namely ',4A5);
	RETURN;

L10:	D=HBEGIN-D;
	T='Days,';
	if (D==1)T='Day, ';
	TYPE 15,D,T,HNAME;
L15:	FORMAT(/' The next holiday will be in',I3,' ',A5,' namely ',4A5);
	RETURN;
	END;
#endif


// USED BY HOURS (ABOVE) TO PRINT HOURS FOR EITHER WEEKDAYS OR WEEKENDS.

#ifdef WIZARDRY
	SUBROUTINE HOURSX(H,DAY1,DAY2);

	IMPLICIT INTEGER(A-Z);
	LOGICAL FIRST;

	FIRST=true;
	FROM=-1;
	if (H!=0) goto L10;
	TYPE 2,DAY1,DAY2;
L2:	FORMAT(10X,2A5,'  Open all day');
	RETURN;

L10:	FROM=FROM+1;
	if ((H & SHIFT(1,FROM))!=0) goto L10;
	if (FROM>=24) goto L20;
	TILL=FROM;
L14:	TILL=TILL+1;
	if ((H & SHIFT(1,TILL))==0 & TILL!=24) goto L14;
	if (FIRST)TYPE 16,DAY1,DAY2,FROM,TILL;
	if (!FIRST)TYPE 18,FROM,TILL;
L16:	FORMAT(10X,2A5,I4,':00 to',I3,':00');
L18:	FORMAT(20X,I4,':00 to',I3,':00');
	FIRST=false;
	FROM=TILL;
	goto L10;

L20:	if (FIRST)TYPE 22,DAY1,DAY2;
L22:	FORMAT(10X,2A5,'  Closed all day');
	RETURN;
	END;
#endif


// SET UP NEW HOURS FOR THE CAVE.  SPECIFIED AS INVERSE--I.E., WHEN IS IT
// CLOSED DUE TO PRIME TIME?  SEE HOURS (ABOVE) FOR DESC OF VARIABLES.

#ifdef WIZARDRY
	SUBROUTINE NEWHRS;

	IMPLICIT INTEGER(A-Z);
	DIMENSION HNAME(4);
	COMMON /WIZCOM/ WKDAY,WKEND,HOLID,HBEGIN,HEND,HNAME;

	MSPEAK(21);
	WKDAY=NEWHRX('Weekd','ays:');
	WKEND=NEWHRX('Weeke','nds:');
	HOLID=NEWHRX('Holid','ays:');
	MSPEAK(22);
	HOURS;
	RETURN;
	END;
#endif


// INPUT PRIME TIME SPECS AND SET UP A WORD OF INTERNAL FORMAT.

#ifdef WIZARDRY
	INTEGER FUNCTION NEWHRX(DAY1,DAY2);

	IMPLICIT INTEGER(A-Z);

	NEWHRX=0;
	TYPE 1,DAY1,DAY2;
L1:	FORMAT(' Prime time on ',2A5);
L10:	TYPE 2;
L2:	FORMAT(' from:');
	ACCEPT 3,FROM;
L3:	FORMAT(G);
	if (FROM<0 | FROM>=24)RETURN;
	TYPE 4;
L4:	FORMAT(' till:');
	ACCEPT 3,TILL;
	TILL=TILL-1;
	if (TILL<FROM | TILL>=24)RETURN;
	DO 5 I=FROM,TILL;
	IDONDX=I;
L5:	NEWHRX=(NEWHRX | SHIFT(1,IDONDX));
	goto L10;
	END;
#endif


// HANDLES MESSAGE OF THE DAY.  IF ALTER IS TRUE, READ A NEW MESSAGE FROM THE
// WIZARD.  ELSE PRINT THE CURRENT ONE.  MESSAGE IS INITIALLY NULL.

#ifdef WIZARDRY
	SUBROUTINE MOTD(ALTER);

	IMPLICIT INTEGER(A-Z);
	LOGICAL ALTER;
	DIMENSION MSG(100);
	DATA MSG/100*-1/;

	if (ALTER) goto L50;

	K=1;
L10:	if (MSG(K)<0)RETURN;
	TYPE 20,(MSG(I),I=K+1,MSG(K)-1);
L20:	FORMAT(' ',14A5);
	K=MSG(K);
	goto L10;

L50:	M=1;
	MSPEAK(23);
L55:	ACCEPT 56,(MSG(I),I=M+1,M+14),K;
L56:	FORMAT(15A5);
	if (K==' ') goto L60;
	MSPEAK(24);
	goto L55;
L60:	DO 62 I=1,14;
	K=M+15-I;
	if (MSG(K)!=' ') goto L65;
L62:	CONTINUE;
	goto L90;
L65:	MSG(M)=K+1;
	M=K+1;
	if (M+14<100) goto L55;
	MSPEAK(25);
L90:	MSG(M)=-1;
	RETURN;
	END;
#endif


// AS PART OF DATABASE INITIALISATION, WE CALL POOF TO SET UP SOME DUMMY
// PRIME-TIME SPECS, MAGIC WORDS, ETC.

#ifdef WIZARDRY
	SUBROUTINE POOF;

	IMPLICIT INTEGER(A-Z);
	DIMENSION HNAME(4);
	COMMON /WIZCOM/ WKDAY,WKEND,HOLID,HBEGIN,HEND,HNAME,;
		SHORT,MAGIC,MAGNM,LATNCY,SAVED,SAVET,SETUP;

	WKDAY=00777400;
	WKEND=0;
	HOLID=0;
	HBEGIN=0;
	HEND=-1;
	SHORT=30;
	MAGIC='DWARF';
	MAGNM=11111;
	LATNCY=90;
	RETURN;
	END;
#endif


// UTILITY ROUTINES (SHIFT, RAN, DATIME, CIAO, BUG);

// SINCE THE RAN FUNCTION IN LIB40 SEEMS TO BE A REAL LOSE, WE'LL USE ONE OF
// OUR OWN.  IT'S BEEN RUN THROUGH MANY OF THE TESTS IN KNUTH VOL. 2 AND
// SEEMS TO BE QUITE RELIABLE.  RAN RETURNS A VALUE UNIFORMLY SELECTED
// BETWEEN 0 AND RANGE-1.  NOTE RESEMBLANCE TO ALG USED IN WIZARD.

int RAN(int RANGE)
{
	static int R=0;
	int T,D;

	D=1;
	if (R==0) {
	  DATIME(&D,&T);
	  R=18*T+5;
	  D=1000+MOD(D,1000);
	}
	for (T=1; T<=D; T++) {
	  R=MOD(R*1021,1048576);
	}
	return (RANGE*R)/1048576;
}


// RETURN THE DATE AND TIME IN D AND T.  D IS NUMBER OF DAYS SINCE 01-JAN-77,
// T IS MINUTES PAST MIDNIGHT.  THIS IS HARDER THAN IT SOUNDS, BECAUSE THE
// FINAGLED DEC FUNCTIONS RETURN THE VALUES ONLY AS ASCII STRINGS!

void DATIME(int* D, int* T)
{
  time_t seconds;
  const time_t seconds_per_day = 60 * 60 * 24;

  seconds = time(NULL);
  *T = (seconds % seconds_per_day) / 60;  // minutes past midnight
  *D = (seconds / seconds_per_day) + (7 * 365 + 2);
}


// EXITS, AFTER ISSUING REMINDER TO SAVE NEW CORE IMAGE.  USED WHEN SUSPENDING
// AND WHEN CREATING NEW VERSION VIA MAGIC MODE.  ON SOME SYSTEMS, THE CORE
// IMAGE IS LOST ONCE THE PROGRAM EXITS.  IF SO, SET K=31 INSTEAD OF 32.

#ifdef WIZARDRY

	SUBROUTINE CIAO;

	IMPLICIT INTEGER(A-Z);
	DATA K/32/;

	MSPEAK(K);
	if (K==31) GETIN(A,B,C,D);
	STOP;
	END;
#endif 


////////////////////////////////////////////////////////////////////////////
// BUG
//
// THE FOLLOWING CONDITIONS ARE CURRENTLY CONSIDERED FATAL BUGS.  NUMBERS < 20
// ARE DETECTED WHILE READING THE DATABASE; THE OTHERS OCCUR AT "RUN TIME".
//	0	MESSAGE LINE > 70 CHARACTERS
//	1	NULL LINE IN MESSAGE
//	2	TOO MANY WORDS OF MESSAGES
//	3	TOO MANY TRAVEL OPTIONS
//	4	TOO MANY VOCABULARY WORDS
//	5	REQUIRED VOCABULARY WORD NOT FOUND
//	6	TOO MANY RTEXT OR MTEXT MESSAGES
//	7	TOO MANY HINTS
//	8	LOCATION HAS COND BIT BEING SET TWICE
//	9	INVALID SECTION NUMBER IN DATABASE
//	20	SPECIAL TRAVEL (500>L>300) EXCEEDS GOTO LIST
//	21	RAN OFF END OF VOCABULARY TABLE
//	22	VOCABULARY TYPE (N/1000) NOT BETWEEN 0 AND 3
//	23	INTRANSITIVE ACTION VERB EXCEEDS GOTO LIST
//	24	TRANSITIVE ACTION VERB EXCEEDS GOTO LIST
//	25	CONDITIONAL TRAVEL ENTRY WITH NO ALTERNATIVE
//	26	LOCATION HAS NO TRAVEL ENTRIES
//	27	HINT NUMBER EXCEEDS GOTO LIST
//	28	INVALID MONTH RETURNED BY DATE FUNCTION
////////////////////////////////////////////////////////////////////////////

void BUG(int NUM)
{
    printf(" Fatal error, see source code for interpretation.\n"
	   " Probable cause: erroneous info in database.\n"
	   " Error code = %d\n", NUM);
    putchar('\n');
    exit(1);
}

